;********************************************************************
; ALIEN EXPLOSION MODULE                                            *
;********************************************************************
;********************************************************************
; Subroutine:   ExplosionUpdate
;********************************************************************
ExplosionUpdate
                jsr AlienExplosionUpdate
                jsr ParticleExplosionUpdate
                rts

;********************************************************************
; Subroutine:   AlienExplosionUpdate
;********************************************************************
AlienExplosionUpdate
                ldy #TIMER_8
                lda timerState,Y
                cmp #TIMER_STATE_THRESHOLD
                bne .alienexplosionupdate_notask
                jsr RestartTimer
                ;do task ********************************************
                lda #$00
                sta explosionFleetIndex
.alienexplosionupdate_next
                ldx explosionFleetIndex
                lda alienExplosionArray,X
                cmp #EXPLOSION_TYPE_A
                bne .alienexplosionupdate_typeb
                jsr DrawAlienExplosionFrame
                jsr AlienExplosionUpdateFrame
                jmp .alienexplosionupdate_skip
.alienexplosionupdate_typeb
                ldx explosionFleetIndex
                lda alienExplosionArray,X
                cmp #EXPLOSION_TYPE_B
                bne .alienexplosionupdate_skip
                jsr AlienExplosionTypeB
                jsr AlienExplosionTypeBUpdateFrame
.alienexplosionupdate_skip
                inc explosionFleetIndex
                lda explosionFleetIndex
                cmp #ALIENS_MAX
                bne .alienexplosionupdate_next
.alienexplosionupdate_notask
                rts

;********************************************************************
; Subroutine:   DrawAlienExplosionFrame
; Input:        alienExplosionXArray
;               alienExplosionYArray
;               alienExplosionFrameArray
;               fleetIndex
;********************************************************************
DrawAlienExplosionFrame
                ldy explosionFleetIndex
                lda alienExplosionXArray,Y
                sta CURRENTSHAPEXPOS
                lda alienExplosionYArray,Y
                sta CURRENTSHAPEYPOS
                lda alienExplosionFrameArray,Y
                tax
                lda alienExplosionFrameLow,X
                sta STRINGL
                lda alienExplosionFrameHigh,X
                sta STRINGH
                lda alienExplosionColorFrameLow,X
                sta TEXTCOLORL
                lda alienExplosionColorFrameHigh,X
                sta TEXTCOLORH
                lda #$02
                sta BLOCKWIDTH
                lda #$03
                sta BLOCKHEIGHT
                lda #SCREEN_WIDTH-3
                sta MAXSCREENX
                jsr DrawShape
                rts

;********************************************************************
; Subroutine:   AlienExplosionUpdateFrame
;********************************************************************
AlienExplosionUpdateFrame
                ldx explosionFleetIndex
                inc alienExplosionFrameArray,X
                lda alienExplosionFrameArray,X
                cmp #$07
                bne .alienexplosionupdateframe_exit
                ;animation finished
                lda #$00
                sta alienExplosionFrameArray,X
                sta alienExplosionArray,X
.alienexplosionupdateframe_exit
                rts

;********************************************************************
; Subroutine:   AlienExplosionTypeBUpdateFrame
;********************************************************************
AlienExplosionTypeBUpdateFrame
                clc
                lda EXPLOSIONBPOINTERL
                adc #$0A                ;number of fields
                sta EXPLOSIONBPOINTERL
                lda EXPLOSIONBPOINTERH
                adc #$00
                sta EXPLOSIONBPOINTERH
                ldx explosionFleetIndex
                lda EXPLOSIONBPOINTERL
                sta alienExplosionPointerArrayL,X
                lda EXPLOSIONBPOINTERH
                sta alienExplosionPointerArrayH,X
                inc alienExplosionFrameArray,X
                lda alienExplosionFrameArray,X
                cmp #$0A
                bne .alienexplosiontypebupdateframe_exit
                ;animation finished
                lda #$00
                sta alienExplosionFrameArray,X
                sta alienExplosionArray,X
                lda #<explosionBpositionTable
                sta EXPLOSIONBPOINTERL
                sta alienExplosionPointerArrayL,X
                lda #>explosionBpositionTable
                sta EXPLOSIONBPOINTERH
                sta alienExplosionPointerArrayH,X
.alienexplosiontypebupdateframe_exit
                rts

;********************************************************************
; Subroutine:   AlienExplosionsPending
;********************************************************************
AlienExplosionsPending
                lda #FALSE
                sta EXPLOSIONSPENDING
                ldx #$00
.alienexplosionspending_next
                lda alienExplosionArray,X
                cmp #FALSE
                ;none of: EXPLOSION_TYPE_A or EXPLOSION_TYPE_B
                beq .alienexplosionspending_skip
                lda #TRUE
                sta EXPLOSIONSPENDING
                rts
.alienexplosionspending_skip
                inx
                cpx #ALIENS_MAX
                bne .alienexplosionspending_next
                rts

;********************************************************************
; Subroutine:   AlienExplosionTypeB
;********************************************************************
AlienExplosionTypeB
                ;get explosion fields
                ;get pointer from array
                ldx explosionFleetIndex
                lda alienExplosionPointerArrayL,X
                sta EXPLOSIONBPOINTERL
                lda alienExplosionPointerArrayH,X
                sta EXPLOSIONBPOINTERH
                ldy #$00
.alienexplosiontypeb_loop
                lda (EXPLOSIONBPOINTERL),Y
                sta explosionField01,Y
                iny
                cpy #$0A
                ;for all explosion fields
                bne .alienexplosiontypeb_loop
                jsr DrawAlienExplosionTypeBFrame
                rts

;********************************************************************
; Subroutine:   DrawAlienExplosionTypeBFrame
;********************************************************************
DrawAlienExplosionTypeBFrame
                ;delete left part of type b explosion
                ldy explosionFleetIndex
                lda alienExplosionXArray,Y
                sta CURRENTSHAPEXPOS
                lda alienExplosionYArray,Y
                clc
                adc explosionField01
                sta CURRENTSHAPEYPOS
                lda #<alienClearExplosionB
                sta STRINGL
                lda #>alienClearExplosionB
                sta STRINGH
                lda #<alienClearExplosionBColor
                sta TEXTCOLORL
                lda #>alienClearExplosionBColor
                sta TEXTCOLORH
                lda #$02
                sta BLOCKWIDTH
                lda #$03
                sta BLOCKHEIGHT
                lda #SCREEN_WIDTH-3
                sta MAXSCREENX
                jsr DrawShape
                ;delete right part of type b explosion
                ldy explosionFleetIndex
                lda alienExplosionXArray,Y
                sta CURRENTSHAPEXPOS
                lda alienExplosionYArray,Y
                clc
                adc explosionField02
                sta CURRENTSHAPEYPOS
                lda #<alienClearExplosionB
                sta STRINGL
                lda #>alienClearExplosionB
                sta STRINGH
                lda #<alienClearExplosionBColor
                sta TEXTCOLORL
                lda #>alienClearExplosionBColor
                sta TEXTCOLORH
                lda #$02
                sta BLOCKWIDTH
                lda #$03
                sta BLOCKHEIGHT
                lda #SCREEN_WIDTH-3
                sta MAXSCREENX
                jsr DrawShape
.drawalienexplosiontypebframe_skip1
                ;left part of type b explosion
                ldy explosionFleetIndex
                lda alienExplosionXArray,Y
                sta CURRENTSHAPEXPOS
                lda alienExplosionYArray,Y
                clc
                adc explosionField03
                sta CURRENTSHAPEYPOS
                lda explosionField05
                sta STRINGL
                lda explosionField06
                sta STRINGH
                lda #<alienExplosionB1Color
                sta TEXTCOLORL
                lda #>alienExplosionB1Color
                sta TEXTCOLORH
                lda #$02
                sta BLOCKWIDTH
                lda #$03
                sta BLOCKHEIGHT
                lda #SCREEN_WIDTH-3
                sta MAXSCREENX
                jsr DrawShape
                ;right part of type b explosion
                ldy explosionFleetIndex
                lda alienExplosionXArray,Y
                sta CURRENTSHAPEXPOS
                lda alienExplosionYArray,Y
                clc
                adc explosionField04
                sta CURRENTSHAPEYPOS
                lda explosionField07
                sta STRINGL
                lda explosionField08
                sta STRINGH
                lda #<alienExplosionB2Color
                sta TEXTCOLORL
                lda #>alienExplosionB2Color
                sta TEXTCOLORH
                lda #$02
                sta BLOCKWIDTH
                lda #$03
                sta BLOCKHEIGHT
                lda #SCREEN_WIDTH-3
                sta MAXSCREENX
                jsr DrawShape
.drawalienexplosiontypebframe_skip2
                lda explosionField09
                cmp #TRUE
                bne .drawalienexplosiontypebframe_dontdraw
                ;score part low
                ldy explosionFleetIndex
                lda alienExplosionXArray,Y
                sta CURRENTXPOS
                inc CURRENTXPOS
                lda alienExplosionYArray,Y
                sta CURRENTYPOS
                lda #$00
                sta CURRENTDECNUMBER
                lda #SCCO
                sta CURRENTCOLOR
                jsr DrawDecimalRotated
                ;score part high
                ldy explosionFleetIndex
                lda alienExplosionXArray,Y
                sta CURRENTXPOS
                inc CURRENTXPOS
                lda alienExplosionYArray,Y
                sta CURRENTYPOS
                dec CURRENTYPOS
                lda #$20
                sta CURRENTDECNUMBER
                lda #SCCO
                sta CURRENTCOLOR
                jsr DrawDecimalRotated
.drawalienexplosiontypebframe_dontdraw
                lda explosionField10
                cmp #TRUE
                bne .drawalienexplosiontypebframe_dontdelete
                ;delete the score
                ldy explosionFleetIndex
                lda alienExplosionXArray,Y
                sta CURRENTXPOS
                inc CURRENTXPOS
                lda alienExplosionYArray,Y
                sta CURRENTYPOS
                dec CURRENTYPOS
                lda #CHR_SPACE
                sta CURRENTCHARACTER
                lda #WHT
                sta CURRENTCOLOR
                jsr Plot
                inc CURRENTYPOS
                jsr Plot
                inc CURRENTYPOS
                jsr Plot
.drawalienexplosiontypebframe_dontdelete
                rts

;********************************************************************
;alien explosion data ***********************************************
;********************************************************************
;alien explosion type A:
;alien explosion frames 1-5
alienExplosion1
                !byte $77,$74
                !byte $78,$75
                !byte $79,$76

alienExplosion1Color
                !byte RED5,RED3
                !byte RED3,RED5
                !byte RED5,RED3

alienExplosion2
                !byte $7D,$7A
                !byte $7E,$7B
                !byte $7F,$7C

alienExplosion2Color
                !byte RED3,PNK
                !byte YEL6,RED3
                !byte RED3,PNK

alienExplosion3
                !byte $83,$80
                !byte $84,$81
                !byte $85,$82

alienExplosion3Color
                !byte PUR,PUR
                !byte ORG5,PUR
                !byte PUR,PUR

alienExplosion4
                !byte CHR_SPACE,CHR_SPACE
                !byte $86,CHR_SPACE
                !byte CHR_SPACE,CHR_SPACE

alienExplosion4Color
                !byte WHT,WHT
                !byte RED3,WHT
                !byte WHT,WHT

alienExplosion5
                !byte CHR_SPACE,CHR_SPACE
                !byte CHR_SPACE,CHR_SPACE
                !byte CHR_SPACE,CHR_SPACE

alienExplosion5Color
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT

;alien explosion frame table
alienExplosionFrameLow
                !byte <alienExplosion1
                !byte <alienExplosion2
                !byte <alienExplosion1
                !byte <alienExplosion2
                !byte <alienExplosion3
                !byte <alienExplosion4
                !byte <alienExplosion5

alienExplosionFrameHigh
                !byte >alienExplosion1
                !byte >alienExplosion2
                !byte >alienExplosion1
                !byte >alienExplosion2
                !byte >alienExplosion3
                !byte >alienExplosion4
                !byte >alienExplosion5

alienExplosionColorFrameLow
                !byte <alienExplosion1Color
                !byte <alienExplosion2Color
                !byte <alienExplosion1Color
                !byte <alienExplosion2Color
                !byte <alienExplosion3Color
                !byte <alienExplosion4Color
                !byte <alienExplosion5Color
                
alienExplosionColorFrameHigh
                !byte >alienExplosion1Color
                !byte >alienExplosion2Color
                !byte >alienExplosion1Color
                !byte >alienExplosion2Color
                !byte >alienExplosion3Color
                !byte >alienExplosion4Color
                !byte >alienExplosion5Color

alienExplosionArray
                !fill ALIENS_MAX,0

alienExplosionFrameArray
                !fill ALIENS_MAX,0

alienExplosionXArray
                !fill ALIENS_MAX,0

alienExplosionYArray
                !fill ALIENS_MAX,0

alienExplosionPointerArrayL
                !fill ALIENS_MAX,<explosionBpositionTable

alienExplosionPointerArrayH
                !fill ALIENS_MAX,>explosionBpositionTable

explosionFleetIndex
                !byte 0

;alien explosion type B:
alienExplosionB1
                !byte $8B,$87
                !byte $8C,$88
                !byte $86,$86

alienExplosionB1Color
                !byte PNK2,PNK2
                !byte RED3,RED3
                !byte PUR,PUR

alienExplosionB2
                !byte $86,$86
                !byte $8D,$89
                !byte $8E,$8A

alienExplosionB2Color
                !byte PUR,PUR
                !byte RED3,RED3
                !byte PNK2,PNK2

alienClearExplosionB
                !byte CHR_SPACE,CHR_SPACE
                !byte CHR_SPACE,CHR_SPACE
                !byte CHR_SPACE,CHR_SPACE

alienClearExplosionBColor
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT

typeBscoreClear
                !byte CHR_SPACE,CHR_SPACE,CHR_SPACE,0

typeBscoreClearColor
                !byte WHT,WHT,WHT,0

explosionField01
                !byte 0     ;old Y offset of left part
explosionField02
                !byte 0     ;old Y offset of right part
explosionField03
                !byte 0     ;new Y offset of left part
explosionField04
                !byte 0     ;new Y offset of right part
explosionField05
                !byte 0     ;shape of left part low address
explosionField06
                !byte 0     ;shape of left part high address
explosionField07
                !byte 0     ;shape of right part low address
explosionField08
                !byte 0     ;shape of right part high address
explosionField09
                !byte 0     ;draw the score value
explosionField10
                !byte 0     ;del the score value

explosionBpositionTable
                !byte -03, 01, -03, 01, <alienExplosionB1, >alienExplosionB1, <alienExplosionB2, >alienExplosionB2, 0, 0
                !byte -03, 01, -03, 01, <alienExplosionB1, >alienExplosionB1, <alienExplosionB2, >alienExplosionB2, 1, 0
                !byte -03, 01, -04, 02, <alienExplosionB1, >alienExplosionB1, <alienExplosionB2, >alienExplosionB2, 1, 0
                !byte -04, 02, -05, 03, <alienExplosionB1, >alienExplosionB1, <alienExplosionB2, >alienExplosionB2, 1, 0
                !byte -05, 03, -06, 04, <alienExplosionB1, >alienExplosionB1, <alienExplosionB2, >alienExplosionB2, 1, 0
                !byte -06, 04, -07, 05, <alienExplosionB1, >alienExplosionB1, <alienExplosionB2, >alienExplosionB2, 1, 0
                !byte -07, 05, -08, 06, <alienExplosionB1, >alienExplosionB1, <alienExplosionB2, >alienExplosionB2, 1, 0
                !byte -08, 06, -09, 07, <alienExplosionB1, >alienExplosionB1, <alienExplosionB2, >alienExplosionB2, 1, 0
                !byte -09, 07, -10, 08, <alienExplosionB1, >alienExplosionB1, <alienExplosionB2, >alienExplosionB2, 1, 0
                !byte -10, 08, -10, 08, <alienClearExplosionB, >alienClearExplosionB, <alienClearExplosionB, >alienClearExplosionB, 0, 1

;********************************************************************
; ALIEN EXPLOSION MODULE END                                        *
;********************************************************************