;********************************************************************
; BIRD MODULE                                                       *
;********************************************************************
;********************************************************************
; Subroutine:   BirdsInit
;********************************************************************
BirdsInit
                lda #$00
                sta BIRDSTEMP
                sta BIRDFLEET
                sta BIRDFLEETINDEX
                sta BIRDFLEETX
                sta BIRDFLEETY
                sta BIRDFLEETOLDX
                sta BIRDFLEETOLDY
                sta BIRDFRAMEINDEX
                sta BIRDYMOVEOFFSETL
                sta BIRDYMOVEOFFSETH
                sta BIRDXMOVEVALUE
                lda #<birdXAnimationTable
                sta BIRDXMOVEL
                lda #>birdXAnimationTable
                sta BIRDXMOVEH
                ldx #$00
.birdsinit_loop
                ;load initial values
                lda birdFleetInitialArray,X
                sta birdFleetArray,X
                lda birdInitialXArray,X
                sta birdFleetXposArray,X
                sta birdFleetOldXposArray,X
                ;load first values from birdYMoveTable
                lda birdInitialYLowArray,X
                sta birdYMoveOffsetTableLow,X
                sta BIRDYMOVEOFFSETL
                lda birdInitialYHighArray,X
                sta birdYMoveOffsetTableHigh,X
                sta BIRDYMOVEOFFSETH
                ldy #$00
                lda (BIRDYMOVEOFFSETL),Y
                sta birdFleetYposArray,X
                sta birdFleetOldYposArray,X
                iny
                lda (BIRDYMOVEOFFSETL),Y
                sta birdShapeTypeArray,X
                lda #$00
                sta alienExplosionArray,X
                ;loop for each bird
                inx
                cpx #BIRDS_MAX
                bne .birdsinit_loop
                rts

;********************************************************************
; Subroutine:   BirdsIngameInit
;********************************************************************
BirdsIngameInit
                ;fill it up from top with the leftover ones
                jsr RecoverBirdsFleet
                ;resets the arrays for the existing ones
                lda #$00
                sta BIRDSTEMP
                sta BIRDFLEET
                sta BIRDFLEETINDEX
                sta BIRDFLEETX
                sta BIRDFLEETY
                sta BIRDFLEETOLDX
                sta BIRDFLEETOLDY
                sta BIRDFRAMEINDEX
                sta BIRDYMOVEOFFSETL
                sta BIRDYMOVEOFFSETH
                sta BIRDXMOVEVALUE
                lda #<birdXAnimationTable
                sta BIRDXMOVEL
                lda #>birdXAnimationTable
                sta BIRDXMOVEH
                ldx #$00
.birdsingameinit_loop
                ;load initial position values
                lda birdInitialXArray,X
                sta birdFleetXposArray,X
                sta birdFleetOldXposArray,X
                ;load first values from birdYMoveTable
                lda birdInitialYLowArray,X
                sta birdYMoveOffsetTableLow,X
                sta BIRDYMOVEOFFSETL
                lda birdInitialYHighArray,X
                sta birdYMoveOffsetTableHigh,X
                sta BIRDYMOVEOFFSETH
                ldy #$00
                lda (BIRDYMOVEOFFSETL),Y
                sta birdFleetYposArray,X
                sta birdFleetOldYposArray,X
                iny
                lda (BIRDYMOVEOFFSETL),Y
                sta birdShapeTypeArray,X
                lda #$00
                sta alienExplosionArray,X
                ;loop for each bird
                inx
                cpx #BIRDS_MAX
                bne .birdsingameinit_loop
                rts

;********************************************************************
; Subroutine:   RecoverBirdsFleet
;********************************************************************
RecoverBirdsFleet
;count the leftover birds
                lda #$00
                ldx #$00
.recoverbirdsfleet_countloop
                clc
                adc birdFleetArray,X
                inx
                cpx #BIRDS_MAX
                bne .recoverbirdsfleet_countloop
                sta BIRDSTEMP
                cmp #$00
                bne .recoverbirdsfleet_continue
                rts
.recoverbirdsfleet_continue
;delete the fleet
                lda #DELETED
                ldx #$00
.recoverbirdsfleet_delloop
                sta birdFleetArray,X
                inx
                cpx #BIRDS_MAX
                bne .recoverbirdsfleet_delloop
;fill it up from top with the leftover ones
                lda #PRESENT
                ldx #$00
.recoverbirdsfleet_fillloop
                sta birdFleetArray,X
                inx
                cpx BIRDSTEMP
                bne .recoverbirdsfleet_fillloop
                rts

;********************************************************************
; Subroutine:   BirdsUpdate
;********************************************************************
BirdsUpdate
                lda PLAYERACTIVE
                cmp #TRUE
                beq .birdsupdate_continue
                rts
.birdsupdate_continue
                ;only for wave 2
                lda CURRENTWAVE
                cmp #FLOW_WAVE_2
                beq .birdsupdate_continue2
                rts
.birdsupdate_continue2
                ;handle x movement data
                jsr GetBirdXMovementData
                ;bird #1
                lda #$00
                sta BIRDFLEETINDEX
                ldx BIRDFLEETINDEX
                ;birds get variables
                lda birdFleetArray
                sta BIRDFLEET
                cmp #PRESENT
                bne .birdsupdate_skip1
                jsr BirdUpdate
.birdsupdate_skip1
                ;bird #2
                inc BIRDFLEETINDEX
                ldx BIRDFLEETINDEX
                ;birds get variables
                lda birdFleetArray+1
                sta BIRDFLEET
                cmp #PRESENT
                bne .birdsupdate_skip2
                jsr BirdUpdate
.birdsupdate_skip2
                ;bird #3
                inc BIRDFLEETINDEX
                ldx BIRDFLEETINDEX
                ;birds get variables
                lda birdFleetArray+2
                sta BIRDFLEET
                cmp #PRESENT
                bne .birdsupdate_skip3
                jsr BirdUpdate
.birdsupdate_skip3
                ;bird #4
                inc BIRDFLEETINDEX
                ldx BIRDFLEETINDEX
                ;birds get variables
                lda birdFleetArray+3
                sta BIRDFLEET
                cmp #PRESENT
                bne .birdsupdate_skip4
                jsr BirdUpdate
.birdsupdate_skip4
                ;bird #5
                inc BIRDFLEETINDEX
                ldx BIRDFLEETINDEX
                ;birds get variables
                lda birdFleetArray+4
                sta BIRDFLEET
                cmp #PRESENT
                bne .birdsupdate_skip5
                jsr BirdUpdate
.birdsupdate_skip5
                ;bird #6
                inc BIRDFLEETINDEX
                ldx BIRDFLEETINDEX
                ;birds get variables
                lda birdFleetArray+5
                sta BIRDFLEET
                cmp #PRESENT
                bne .birdsupdate_skip6
                jsr BirdUpdate
.birdsupdate_skip6
                ;bird #7
                inc BIRDFLEETINDEX
                ldx BIRDFLEETINDEX
                ;birds get variables
                lda birdFleetArray+6
                sta BIRDFLEET
                cmp #PRESENT
                bne .birdsupdate_skip7
                jsr BirdUpdate
.birdsupdate_skip7
                ;bird #8
                inc BIRDFLEETINDEX
                ldx BIRDFLEETINDEX
                ;birds get variables
                lda birdFleetArray+7
                sta BIRDFLEET
                cmp #PRESENT
                bne .birdsupdate_skip8
                jsr BirdUpdate
.birdsupdate_skip8
                rts

;********************************************************************
; Subroutine:   BirdUpdate
;********************************************************************
BirdUpdate
                lda birdFleetXposArray,X
                sta BIRDFLEETX
                lda birdFleetYposArray,X
                sta BIRDFLEETY
                lda birdFleetOldXposArray,X
                sta BIRDFLEETOLDX
                lda birdFleetOldYposArray,X
                sta BIRDFLEETOLDY
                lda birdShapeTypeArray,X
                sta BIRDSHAPETYPE
                lda birdYMoveOffsetTableLow,X
                sta BIRDYMOVEOFFSETL
                lda birdYMoveOffsetTableHigh,X
                sta BIRDYMOVEOFFSETH
                stx BIRDSTEMP       ;save X register as it gets trashed
                ;old x, y pos becomes current
                lda BIRDFLEETX
                sta BIRDFLEETOLDX
                lda BIRDFLEETY
                sta BIRDFLEETOLDY
                ;reset pointer if end of table reached
                ldy #$00
                lda (BIRDYMOVEOFFSETL),Y
                cmp #EO_BIRDYANIMATIONTABLE
                bne .birdupdate_continue
                ;for current bird
                ldy BIRDFLEETINDEX
                lda birdYAnimationLoopStartTableLow,Y
                sta BIRDYMOVEOFFSETL
                lda birdYAnimationLoopStartTableHigh,Y
                sta BIRDYMOVEOFFSETH
.birdupdate_continue
                ;get bird Y move data
                ldy #$00
                lda (BIRDYMOVEOFFSETL),Y
                sta BIRDFLEETY
                ;get bird frame data
                iny
                lda (BIRDYMOVEOFFSETL),Y
                sta BIRDSHAPETYPE
                ;get pointer to next table entry
                clc
                lda BIRDYMOVEOFFSETL
                adc #$02                ;number of fields
                sta BIRDYMOVEOFFSETL
                lda BIRDYMOVEOFFSETH
                adc #$00
                sta BIRDYMOVEOFFSETH
                ;load and adjust X pos
                clc
                lda BIRDXMOVEVALUE
                adc BIRDFLEETX
                cmp #$FF                ;if x=-1 then x=59
                bne .birdupdate_visible
                lda #$3B
.birdupdate_visible
                cmp #$3C                ;if x=60 then x=0
                bne .birdupdate_visible2
                lda #$00
.birdupdate_visible2
                ;update x pos
                sta BIRDFLEETX
.birdupdate_notask
                ;del old bird
                lda BIRDFLEETOLDX
                sta CURRENTSHAPEXPOS
                lda BIRDFLEETOLDY
                sta CURRENTSHAPEYPOS
                lda #<bird00Shape
                sta STRINGL
                lda #>bird00Shape
                sta STRINGH
                lda #<bird00Color
                sta TEXTCOLORL
                lda #>bird00Color
                sta TEXTCOLORH
                lda #$02
                sta BLOCKWIDTH
                lda #$07
                sta BLOCKHEIGHT
                lda #SCREEN_WIDTH-3
                sta MAXSCREENX
                jsr DrawShape
                ;draw bird with collision check
                jsr DrawBirdCollisionCheck
                ;bullet collision handling
                jsr BirdBulletCollisions
                ;shield collission handling
                jsr BirdShieldPlayerCollisions
                ;bird bullet fire
                jsr BirdUpdateFiring
                ;birds set variables
                ldx BIRDSTEMP
                lda BIRDFLEET
                sta birdFleetArray,X
                lda BIRDFLEETX
                sta birdFleetXposArray,X
                lda BIRDFLEETY
                sta birdFleetYposArray,X
                lda BIRDFLEETOLDX
                sta birdFleetOldXposArray,X
                lda BIRDFLEETOLDY
                sta birdFleetOldYposArray,X
                lda BIRDSHAPETYPE
                sta birdShapeTypeArray,X
                lda BIRDYMOVEOFFSETL
                sta birdYMoveOffsetTableLow,X
                lda BIRDYMOVEOFFSETH
                sta birdYMoveOffsetTableHigh,X
                rts

;********************************************************************
; Subroutine:   GetBirdXMovementData
;********************************************************************
GetBirdXMovementData
                ldy #TIMER_G
                lda timerState,Y
                cmp #TIMER_STATE_THRESHOLD
                bne .getbirdxmovementdata_notask
                ;do task ********************************************
                ;reset pointer if end of table reached
                ldy #$00
                lda (BIRDXMOVEL),Y
                cmp #EO_BIRDXANIMATIONTABLE
                bne .getbirdxmovementdata_continue
                lda #<birdXAnimationLoopStart
                sta BIRDXMOVEL
                lda #>birdXAnimationLoopStart
                sta BIRDXMOVEH
.getbirdxmovementdata_continue
                ;get move value (-1, +1)
                lda (BIRDXMOVEL),Y
                sta BIRDXMOVEVALUE
                ;get timer value low byte
                iny
                lda (BIRDXMOVEL),Y
                sta BIRDXMOVETIMERVALUE
                ;set pointer to next table entry
                clc
                lda BIRDXMOVEL
                adc #$02                ;number of fields
                sta BIRDXMOVEL
                lda BIRDXMOVEH
                adc #$00
                sta BIRDXMOVEH
                ;setup new timer values
                ldy #TIMER_G
                lda #$00                    ;timer value high byte
                ldx BIRDXMOVETIMERVALUE     ;timer value low byte
                jsr SetTimerValue
                jsr RestartTimer
.getbirdxmovementdata_notask
                rts

;********************************************************************
; Subroutine:   DrawBirdCollisionCheck
;********************************************************************
DrawBirdCollisionCheck
                lda BIRDFLEETX
                sta CURRENTSHAPEXPOS
                lda BIRDFLEETY
                sta CURRENTSHAPEYPOS
                ldx BIRDSHAPETYPE
                lda birdShapeAddrTableLow,X
                sta STRINGL
                lda birdShapeAddrTableHigh,X
                sta STRINGH
                lda birdColorAddrTableLow,X
                sta TEXTCOLORL
                lda birdColorAddrTableHigh,X
                sta TEXTCOLORH
                lda #$02
                sta BLOCKWIDTH
                lda #$07
                sta BLOCKHEIGHT
                lda #SCREEN_WIDTH-3
                sta MAXSCREENX
                ;DrawShapeCollisionCheck
                tya
                pha
                lda #$00
                sta SHAPEDATAINDEX
                lda CURRENTSHAPEYPOS
                sta CHRYPOS
.drawbirdcollisioncheck_nextline
                lda CURRENTSHAPEXPOS
                sta CHRXPOS
.drawbirdcollisioncheck_posallowed
                lda CHRXPOS
                ;X position >= 0 ?
                bmi .drawbirdcollisioncheck_nextchr
                ;X position < 37 ?
                cmp MAXSCREENX
                bpl .drawbirdcollisioncheck_nextchr
                ;Y position >= 0 ?
                ldy CHRYPOS
                bmi .drawbirdcollisioncheck_nextchr
                ;Y position < 24 ?
                cpy #SCREEN_HIGHT
                bpl .drawbirdcollisioncheck_nextchr
                ;set screen ram
                clc
                adc screenRAMRowLow,Y
                sta SCREENRAML
                sta COLORRAML
                lda #$00
                adc screenRAMRowHigh,Y
                sta SCREENRAMH
                eor #>(SCREENRAM XOR COLORRAM)
                sta COLORRAMH
                ;collision check
                jsr BirdCollisionCheck
                ;write to screen/color ram
                ldy SHAPEDATAINDEX
                lda (STRINGL),Y
                beq .drawbirdcollisioncheck_nextchr   ;skip if CHR code 0
                ldy #$00
                sta (SCREENRAML),Y
                ldy SHAPEDATAINDEX
                lda (TEXTCOLORL),Y
                ldy #$00
                sta (COLORRAML),Y
                ;move to next character
.drawbirdcollisioncheck_nextchr
                inc SHAPEDATAINDEX
                inc CHRXPOS
                ;end of line reached?
                clc
                lda CURRENTSHAPEXPOS
                clc
                adc BLOCKWIDTH
                cmp CHRXPOS
                bne .drawbirdcollisioncheck_posallowed
                inc CHRYPOS
                dec BLOCKHEIGHT
                ;end of block reached ?
                beq .drawbirdcollisioncheck_exit
                ;next block line
                bne .drawbirdcollisioncheck_nextline
.drawbirdcollisioncheck_exit
                pla
                tay
                rts

;********************************************************************
; Subroutine:   BirdCollisionCheck
;********************************************************************
BirdCollisionCheck
                ldy #$00
                lda (COLORRAML),Y
                cmp #SHIP_COLOR_1       ;BGR4
                beq .birdcollisioncheck_alienplayer
                cmp #SHIP_COLOR_2       ;BGRN
                beq .birdcollisioncheck_alienplayer
                cmp #SHIP_COLOR_3       ;PNK3
                beq .birdcollisioncheck_alienshield
                cmp #SHIP_COLOR_4       ;PNK5
                beq .birdcollisioncheck_alienshield
                lda (SCREENRAML),Y
                cmp #CHR_SHIELD_START
                bcc .birdcollisioncheck_nocoll
                cmp #CHR_SHIELD_END
                bcc .birdcollisioncheck_alienshield
.birdcollisioncheck_nocoll
                rts
                ;****************************************************
                ;Collision check: bird - player ********************
                ;****************************************************
                ;alien has hit player
.birdcollisioncheck_alienplayer
                lda #TRUE
                sta PLAYERALIENCOLLISION
                ;****************************************************
                ;Collision check: bird - player during shield ******
                ;****************************************************
.birdcollisioncheck_alienshield
                ldx BIRDFLEETINDEX
                lda alienCollisionArray,X
                cmp #FALSE
                bne .birdcollisioncheck_exit
                lda #TRUE
                sta alienCollisionArray,X
                lda CURRENTSHAPEXPOS
                sta alienExplosionXArray,X
                lda CURRENTSHAPEYPOS
                sta alienExplosionYArray,X
.birdcollisioncheck_exit
                rts

;********************************************************************
; Subroutine:   BirdShieldPlayerCollisions
;********************************************************************
BirdShieldPlayerCollisions
                ldx BIRDFLEETINDEX
                lda alienCollisionArray,X
                cmp #TRUE
                bne .birdshieldplayercollisions_exit
                ;bird gets destroyed
                lda #FALSE
                sta alienCollisionArray,X
                ;trigger explosion animation
                lda #EXPLOSION_TYPE_A
                sta alienExplosionArray,X
                ;delete bird from screen
                lda BIRDFLEETX
                sta CURRENTSHAPEXPOS
                lda BIRDFLEETY
                sta CURRENTSHAPEYPOS
                lda #<bird00Shape
                sta STRINGL
                lda #>bird00Shape
                sta STRINGH
                lda #<bird00Color
                sta TEXTCOLORL
                lda #>bird00Color
                sta TEXTCOLORH
                lda #$02
                sta BLOCKWIDTH
                lda #$07
                sta BLOCKHEIGHT
                lda #SCREEN_WIDTH-3
                sta MAXSCREENX
                jsr DrawShape
                ;remove bird from fleet
                lda #FALSE
                sta BIRDFLEET
                ;add 40 points to score
                lda #FOURTY_POINTS
                sta VALUETOSCORE
                jsr IncreaseScoreLow
                ;trigger alien explosion sound
                jsr TriggerSoundAlienExplosion
.birdshieldplayercollisions_exit
                rts

;********************************************************************
; Subroutine:   DrawBirdsFadeIn
;********************************************************************
DrawBirdsFadeIn
                ldy #TIMER_B
                lda timerState,Y
                cmp #TIMER_STATE_THRESHOLD
                bne .drawbirdsfadein_notask
                jsr RestartTimer
                ;do task ********************************************
                lda #$00
                sta BIRDFLEETINDEX
.drawbirdsfadein_next
                ldx BIRDFLEETINDEX
                lda birdFleetArray,X
                cmp #PRESENT
                bne .drawbirdsfadein_skip
                lda birdFleetXposArray,X
                sta CURRENTSHAPEXPOS
                lda birdFleetYposArray,X
                sta CURRENTSHAPEYPOS
                ldy FADEINBIRDSFRAMEINDEX
                lda fadeinBirdFrameLow,Y
                sta STRINGL
                lda fadeinBirdFrameHigh,Y
                sta STRINGH
                lda fadeinBirdColorFrameLow,Y
                sta TEXTCOLORL
                lda fadeinBirdColorFrameHigh,Y
                sta TEXTCOLORH
                lda #$02
                sta BLOCKWIDTH
                lda #$07
                sta BLOCKHEIGHT
                lda #SCREEN_WIDTH-3
                sta MAXSCREENX
                jsr DrawShape
.drawbirdsfadein_skip
                inc BIRDFLEETINDEX
                lda BIRDFLEETINDEX
                cmp #BIRDS_MAX
                bne .drawbirdsfadein_next
                ;next frame
                inc FADEINBIRDSFRAMEINDEX
                lda FADEINBIRDSFRAMEINDEX
                cmp #$03
                bne .drawbirdsfadein_notask
                ;fade in animation is finished
                lda #$00
                sta FADEINBIRDSFRAMEINDEX
                lda #TRUE
                sta FADEINBIRDFINISHED
.drawbirdsfadein_notask
                rts

;********************************************************************
; Subroutine:   BirdBulletCollisions
;********************************************************************
BirdBulletCollisions
                ;check for collided bullets
                lda BIRDFLEETX
                sta BULLETSXCHARCOL
                lda BIRDFLEETY
                sta BULLETSYCHARCOL
                ;target is the middle part of bird character
                inc BULLETSYCHARCOL
                inc BULLETSYCHARCOL
                inc BULLETSYCHARCOL
                lda #TRUE
                sta BULLETSDIRCOL
                jsr BulletsCollided
                bne .birdbulletcollisions_collision
                rts
.birdbulletcollisions_collision
                ;delete bird from screen
                lda BIRDFLEETX
                sta CURRENTSHAPEXPOS
                lda BIRDFLEETY
                sta CURRENTSHAPEYPOS
                lda #<bird00Shape
                sta STRINGL
                lda #>bird00Shape
                sta STRINGH
                lda #<bird00Color
                sta TEXTCOLORL
                lda #>bird00Color
                sta TEXTCOLORH
                lda #$02
                sta BLOCKWIDTH
                lda #$07
                sta BLOCKHEIGHT
                lda #SCREEN_WIDTH-3
                sta MAXSCREENX
                jsr DrawShape
                ;remove bird from fleet
                lda #FALSE
                sta BIRDFLEET
                ;trigger alien explosion sound
                jsr TriggerSoundAlienExplosion
                ;trigger explosion animation
                ldx BIRDFLEETINDEX
                lda #EXPLOSION_TYPE_A
                sta alienExplosionArray,X
                lda CURRENTSHAPEXPOS
                sta alienExplosionXArray,X
                clc
                lda CURRENTSHAPEYPOS
                adc #$02                    ;align with explosion shape size
                sta alienExplosionYArray,X
                ;get bird shape type
                lda BIRDSHAPETYPE
                cmp #BIRD_SHAPE_20
                bcs .birdbulletcollisions_typeb    ;branch if birds grown up
                ;add 800 points to score
                lda #EIGHTHUNDRED_POINTS
                sta VALUETOSCORE
                jsr IncreaseScoreHigh
                rts
.birdbulletcollisions_typeb
                ldx BIRDFLEETINDEX
                lda #EXPLOSION_TYPE_B
                sta alienExplosionArray,X
                ;add 200 points to score
                lda #TWOHUNDRED_POINTS
                sta VALUETOSCORE
                jsr IncreaseScoreHigh
                ;trigger score sound
                jsr TriggerSoundScore
                rts

;********************************************************************
; Subroutine:   BirdUpdateFiring
;********************************************************************
BirdUpdateFiring
                ;fire only if player ship underneath bird
                clc
                lda BIRDFLEETY
                adc #$03
                cmp playerY
                bne .birdupdatefiring_dontfire
                ;fire only if bird grown up
                lda BIRDSHAPETYPE
                cmp #BIRD_SHAPE_27
                bcc .birdupdatefiring_dontfire
                ;fire only if x pos >13
                lda BIRDFLEETX
                cmp #$0D
                bcc .birdupdatefiring_dontfire
                ;fire only if x pos <35
                lda BIRDFLEETX
                cmp #$23
                bcs .birdupdatefiring_dontfire
                ldx #$00
.birdupdatefiring_bulletloop
                lda bulletsActive,X
                bne .birdupdatefiring_bulletskip
                ;save the current bullet in the queue
                lda #$01
                sta bulletsActive,X
                lda BIRDFLEETX
                sta bulletsXChar,X
                clc
                lda BIRDFLEETY
                adc #$03
                sta bulletsYChar,X
                lda #CHR_ALIENBULLET1
                sta bulletsYOffset,X
                ;bird bullet color
                lda #ORG5
                sta bulletsColor,X
                ;bird bullet direction
                lda #FALSE
                sta bulletsDir,X
                ;bird bullet speed
                lda #$01
                sta bulletsSpeed,X
                sta bulletsWait,X
                ;trigger the alien firing sound
                jsr TriggerSoundAlienFiring
                ;found a slot, quit the loop
                rts
.birdupdatefiring_bulletskip
                ;loop for each bullet
                inx
                cpx #BULLETS_MAX
                bne .birdupdatefiring_bulletloop
.birdupdatefiring_dontfire
                rts

;********************************************************************
; Subroutine:   DeleteAllBirdsFromScreen
;********************************************************************
DeleteAllBirdsFromScreen
                lda #$00
                sta BIRDFLEETINDEX
.deleteallbirdsfromscreen_next
                ldx BIRDFLEETINDEX
                lda birdFleetArray,X
                cmp #PRESENT
                bne .deleteallbirdsfromscreen_skip
                lda birdFleetXposArray,X
                sta CURRENTSHAPEXPOS
                lda birdFleetYposArray,X
                sta CURRENTSHAPEYPOS
                lda #<bird00Shape
                sta STRINGL
                lda #>bird00Shape
                sta STRINGH
                lda #<bird00Color
                sta TEXTCOLORL
                lda #>bird00Color
                sta TEXTCOLORH
                lda #$02
                sta BLOCKWIDTH
                lda #$07
                sta BLOCKHEIGHT
                lda #SCREEN_WIDTH-3
                sta MAXSCREENX
                jsr DrawShape
.deleteallbirdsfromscreen_skip
                inc BIRDFLEETINDEX
                lda BIRDFLEETINDEX
                cmp #BIRDS_MAX
                bne .deleteallbirdsfromscreen_next
                rts

;********************************************************************
;bird data **********************************************************
;********************************************************************

;for all birds
;x-offset, next timer low value
birdXAnimationTable
                !byte   0, 20
                !byte  -1, 02
                !byte   0, 19
                !byte  -1, 02
                !byte   0, 18
                !byte  -1, 02
                !byte   0, 17
                !byte  -1, 02
                !byte   0, 16
                !byte  -1, 02
                !byte   0, 15
                !byte  -1, 02
                !byte   0, 14
                !byte  -1, 02
                !byte   0, 20
                !byte   1, 02
                !byte   0, 19
                !byte   1, 02
                !byte   0, 18
                !byte   1, 02
                !byte   0, 17
                !byte   1, 02
                !byte   0, 18
                !byte   1, 02
                !byte   0, 45
                !byte  -1, 02
                !byte   0, 15
                !byte  -1, 02
                !byte   0, 14
                !byte  -1, 02
                !byte   0, 13
                !byte  -1, 02
                !byte   0, 12
                !byte   1, 02
                !byte   0, 11
                !byte   1, 02
                !byte   0, 10
                !byte   1, 02
                !byte   0, 09
                !byte   1, 02
                !byte   0, 11
                !byte   1, 02
                !byte   0, 10
                !byte   1, 02
                !byte   0, 34
                !byte  -1, 02
                !byte   0, 10
                !byte  -1, 02
                !byte   0, 10
                !byte  -1, 02
                !byte   0, 10
                !byte   1, 02
                !byte   0, 20
                !byte   1, 02
                !byte   0, 12
                !byte  -1, 02
                !byte   0, 11
                !byte  -1, 02
                !byte   0, 09
                !byte   1, 02
                !byte   0, 08
                !byte  -1, 02
                !byte   0, 07
                !byte  -1, 02
                !byte   0, 06
                !byte  -1, 02
                !byte   0, 05
                !byte  -1, 02
                !byte   0, 04
                !byte  -1, 02
                !byte   0, 03
                !byte  -1, 02
                !byte   0, 03
                !byte  -1, 02
                !byte   0, 03
                !byte  -1, 02
                !byte   0, 04
                !byte  -1, 02
                !byte   0, 05
                !byte  -1, 02
                !byte   0, 06
                !byte   1, 02
                !byte   0, 08
                !byte   1, 02
                !byte   0, 15
                !byte   1, 02
                !byte   0, 20
                !byte   1, 02
                !byte   0, 40
                !byte   1, 02
                !byte   0, 50

                !byte   1, 02
                !byte   0, 08
                !byte   1, 02
                !byte   0, 15
                !byte   1, 02
                !byte   0, 20
                !byte   1, 02
                !byte   0, 40
                !byte   1, 02
                !byte   0, 35

                !byte  -1, 02
                !byte   0, 07
                !byte  -1, 02
                !byte   0, 06
                !byte  -1, 02
                !byte   0, 04
                !byte  -1, 02
                !byte   0, 02
                !byte  -1, 02
                !byte   0, 02
                !byte  -1, 02
                !byte   0, 02
                !byte  -1, 02
                !byte   0, 02
                !byte   1, 02
                !byte   0, 02
                !byte  -1, 02
                !byte   0, 08
                !byte  -1, 02
                !byte   0, 07
                !byte  -1, 02
                !byte   0, 06
                !byte  -1, 02
                !byte   0, 05
                !byte  -1, 02
                !byte   0, 15
                !byte   1, 02
                !byte   0, 35
                !byte   1, 02
                !byte   0, 60
                !byte  -1, 02
                !byte   0, 03
                !byte  -1, 02
                !byte   0, 02
                !byte   0, 09
                !byte   1, 02
                !byte   0, 08
                !byte  -1, 02
                !byte   0, 07
                !byte  -1, 02
                !byte   0, 06
                !byte  -1, 02
                !byte   0, 05
                !byte  -1, 02
                !byte   0, 04
                !byte  -1, 02
                !byte   0, 03
                !byte  -1, 02
                !byte   0, 03
                !byte  -1, 02
                !byte   0, 03
                !byte  -1, 02
                !byte   0, 04
                !byte  -1, 02
                !byte   0, 05
                !byte  -1, 02
                !byte   0, 06
                !byte   1, 02
                !byte   0, 08
                !byte   1, 02
                !byte   0, 15
                !byte   1, 02
                !byte   0, 20
                !byte   1, 02
                !byte   0, 40
                !byte   1, 02
                !byte   0, 20
                !byte  -1, 02
                !byte   0, 07
                !byte  -1, 02
                !byte   0, 06
                !byte  -1, 02
                !byte   0, 04
                !byte  -1, 02
                !byte   0, 02
                !byte  -1, 02
                !byte   0, 02
                !byte  -1, 02
                !byte   0, 02
                !byte  -1, 02
                !byte   0, 02
                !byte   1, 02
                !byte   0, 02
                !byte  -1, 02
                !byte   0, 08
                !byte  -1, 02
                !byte   0, 07
                !byte  -1, 02
                !byte   0, 06
                !byte  -1, 02
                !byte   0, 05
                !byte  -1, 02
                !byte   0, 10
                !byte   1, 02
                !byte   0, 08
                !byte   1, 02
                !byte   0, 07
                !byte  -1, 02
                !byte   0, 05
                !byte  -1, 02
birdXAnimationLoopStart
                !byte   0, 05
                !byte   1, 02
                !byte   0, 05
                !byte  -1, 02
                !byte   0, 05
                !byte  -1, 02
                !byte   0, 05
                !byte  -1, 02
                !byte   0, 05
                !byte  -1, 02
                !byte   0, 05
                !byte  -1, 02
                !byte   0, 05
                !byte  -1, 02
                !byte   0, 05
                !byte  -1, 02
                !byte   0, 05
                !byte  -1, 02
                !byte   0, 05
                !byte  -1, 02
                !byte   0, 05
                !byte  -1, 02
                !byte   0, 05
                !byte   1, 02
                !byte   0, 04
                !byte   1, 02
                !byte   0, 04
                !byte   1, 02
                !byte   0, 04
                !byte   1, 02
                !byte   0, 04
                !byte   1, 02
                !byte   0, 04
                !byte  -1, 02
                !byte   0, 04
                !byte  -1, 02
                !byte   0, 04
                !byte  -1, 02
                !byte   0, 04
                !byte  -1, 02
                !byte   0, 04
                !byte  -1, 02
                !byte   0, 04
                !byte  -1, 02
                !byte   0, 04
                !byte  -1, 02
                !byte   0, 04
                !byte   1, 02
                !byte   0, 04
                !byte  -1, 02
                !byte   0, 04
                !byte  -1, 02
                !byte   0, 03
                !byte  -1, 02
                !byte   0, 03
                !byte  -1, 02
                !byte   0, 03
                !byte  -1, 02
                !byte   0, 03
                !byte   1, 02
                !byte   0, 03
                !byte   1, 02
                !byte   0, 03
                !byte  -1, 02
                !byte   0, 03
                !byte  -1, 02
                !byte   0, 03
                !byte EO_BIRDXANIMATIONTABLE    ;loop end

;from Bird #1 OK (backwards #6)
;y-position, shape#
bird1YAnimationTable
bird1Y0
                !byte   0,  3
                !byte   0,  6
                !byte   1,  3
                !byte   1,  6
bird1Y2
                !byte   2,  3
                !byte   2,  5
                !byte   3,  3
                !byte   3,  4
bird1Y4
                !byte   4,  3
                !byte   4,  6
                !byte   5,  3
                !byte   5,  6
bird1Y6
                !byte   6,  3
                !byte   6,  6
                !byte   7,  3
                !byte   7,  3
bird1Y8
                !byte   8,  4
                !byte   8,  6
                !byte   9,  4
                !byte   9,  6
bird1Y10
                !byte  10,  3
                !byte  10,  6
                !byte  11,  3
                !byte  11,  4
                !byte  11,  6
bird1Y12
                !byte  12,  3
                !byte  12,  3
                !byte  12,  4
                !byte  12,  5
                !byte  12,  6
                !byte  12,  6
                !byte  13,  3
                !byte  13,  4
                !byte  13,  5
                !byte  13,  6
bird1Y14
                !byte  14,  3
                !byte  14,  4
                !byte  14,  6
                !byte  15,  3
                !byte  15,  4
                !byte  15,  5
                !byte  15,  6
bird1Y16
                !byte  16,  3
                !byte  16,  4
                !byte  16,  4
                !byte  16,  5
                !byte  16,  6
                !byte  16,  6
bird1Y17
                !byte  17,  3
                !byte  16,  6
                !byte  16,  6
                !byte  16,  5
                !byte  16,  8
                !byte  16,  8
                !byte  16,  7
                !byte  16,  7
                !byte  16,  7
                !byte  15, 10
                !byte  15,  9
                !byte  15,  8
                !byte  15,  7
                !byte  15,  7
                !byte  14, 10
                !byte  14,  9
                !byte  14,  7
                !byte  14,  7
                !byte  13, 10
                !byte  13,  8
                !byte  12, 10
                !byte  12, 10
                !byte  12,  8
                !byte  11, 10
                !byte  11,  8
                !byte  10, 10
                !byte  10,  8
                !byte  10,  8
                !byte   9, 10
                !byte   9,  8
                !byte   8, 10
                !byte   8,  8
                !byte   7, 10
                !byte   7,  8
                !byte   6, 10
                !byte   6,  8
                !byte   5, 10
                !byte   5,  8
                !byte   4, 10
                !byte   4,  8
                !byte   3, 10
                !byte   3, 12
                !byte   2, 14
                !byte   2, 12
                !byte   2, 11
                !byte   1, 14
                !byte   1, 12
                !byte   0, 14
                !byte   0, 12
                !byte  -1, 14
                !byte  -1, 12
                !byte  -2, 14
                !byte  -2, 14
                !byte  -3, 14
                !byte  -3, 14
                !byte  -3, 12
                !byte  -3, 12
                !byte  -3, 11
                !byte  -4, 14
                !byte  -4, 14
                !byte  -4, 13
                !byte  -4, 13
                !byte  -4, 12
                !byte  -4, 12
                !byte  -4, 12
                !byte  -4, 11
                !byte  -4, 11
                !byte  -4, 11
                !byte  -4, 11
                !byte  -4, 11
                !byte  -4, 11
                !byte  -3, 12
                !byte  -3, 12
                !byte  -3, 13
                !byte  -3, 13
                !byte  -3, 13
                !byte  -3, 14
                !byte  -3, 14
                !byte  -3, 14
                !byte  -2, 11
                !byte  -2, 12
                !byte  -2, 13
                !byte  -2, 14
                !byte  -2, 14
                !byte  -1, 11
                !byte  -1, 11
                !byte  -1, 11
                !byte  -1, 14
                !byte  -1, 14
                !byte   0, 11
                !byte   0, 13
                !byte   1, 11
                !byte   1, 11
                !byte   1, 14
                !byte   2, 11
                !byte   2, 11
                !byte   2, 13
                !byte   3, 11
                !byte   3, 14
                !byte   4, 11
                !byte   4, 11
                !byte   4, 13
                !byte   5, 11
                !byte   5, 14
                !byte   5, 14
                !byte   6, 11
                !byte   6, 11
                !byte   6, 13
                !byte   7, 11
                !byte   7, 14
                !byte   7, 14
                !byte   8, 11
                !byte   8, 13
                !byte   9, 11
                !byte   9, 14
                !byte   9, 14
                !byte  10, 11
                !byte  10, 11
                !byte  10, 13
                !byte  11, 11
                !byte  11, 12
                !byte  11, 12
                !byte  11, 14
                !byte  11, 14
                !byte  12, 11
                !byte  12, 13
                !byte  12, 14
                !byte  13, 11
                !byte  13, 12
                !byte  13, 14
                !byte  14, 12
                !byte  14, 13
                !byte  14, 14
                !byte  15, 11
                !byte  15, 13
                !byte  15, 14
                !byte  16, 11
                !byte  16, 16
                !byte  16, 16
                !byte  16, 17
                !byte  16, 17
                !byte  16, 18
                !byte  16, 19
                !byte  16, 19
                !byte  16, 20
                !byte  16, 21
                !byte  16, 21
                !byte  15, 27
                !byte  15, 26
                !byte  15, 25
                !byte  15, 21
                !byte  14, 27
                !byte  14, 26
                !byte  14, 21
                !byte  13, 27
                !byte  13, 25
                !byte  12, 27
                !byte  12, 25
                !byte  11, 27
                !byte  11, 25
                !byte  10, 27
                !byte  10, 25
bird1YAnimationLoopStart
                !byte  10, 21       ;loop start
                !byte  10, 21
                !byte  10, 21
                !byte  10, 21
                !byte  10, 21
                !byte  10, 22
                !byte  10, 22
                !byte  10, 22
                !byte  10, 22
                !byte  10, 23
                !byte  10, 23
                !byte  10, 23
                !byte  10, 23
                !byte  10, 23
                !byte  10, 23
                !byte  10, 24
                !byte  10, 28
                !byte  10, 29
                !byte  10, 30
                !byte  11, 28
                !byte  11, 30
                !byte  12, 28
                !byte  12, 30
                !byte  13, 28
                !byte  13, 30
                !byte  14, 29
                !byte  14, 24
                !byte  14, 24
                !byte  14, 24
                !byte  14, 23
                !byte  14, 23
                !byte  14, 22
                !byte  14, 21
                !byte  14, 21
                !byte  14, 22
                !byte  14, 23
                !byte  14, 23
                !byte  14, 24
                !byte  14, 24
                !byte  14, 24
                !byte  14, 24
                !byte  14, 24
                !byte  14, 24
                !byte  14, 29
                !byte  14, 30
                !byte  15, 24
                !byte  15, 28
                !byte  16, 24
                !byte  16, 28
                !byte  16, 29
                !byte  16, 30
                !byte  17, 24
                !byte  17, 24
                !byte  17, 28
                !byte  17, 28
                !byte  17, 29
                !byte  17, 29
                !byte  17, 30
                !byte  17, 30
                !byte  18, 24
                !byte  17, 30
                !byte  17, 30
                !byte  17, 29
                !byte  17, 29
                !byte  17, 28
                !byte  17, 28
                !byte  17, 24
                !byte  17, 24
                !byte  17, 24
                !byte  17, 24
                !byte  17, 24
                !byte  17, 23
                !byte  17, 23
                !byte  17, 22
                !byte  17, 21
                !byte  17, 21
                !byte  17, 22
                !byte  17, 23
                !byte  17, 23
                !byte  17, 24
                !byte  17, 24
                !byte  17, 24
                !byte  17, 24
                !byte  17, 24
                !byte  16, 30
                !byte  16, 29
                !byte  16, 28
                !byte  15, 30
                !byte  15, 29
                !byte  15, 24
                !byte  14, 29
                !byte  14, 24
                !byte  13, 29
                !byte  13, 24
                !byte  12, 29
                !byte  12, 24
                !byte  11, 29
                !byte  11, 24
                !byte  10, 29
                !byte  10, 24
                !byte   9, 29
                !byte   9, 24
                !byte   8, 29
                !byte   8, 24
                !byte   7, 30
                !byte   7, 28
                !byte   7, 24
                !byte   6, 30
                !byte   6, 29
                !byte   6, 28
                !byte   6, 24
                !byte   5, 30
                !byte   5, 30
                !byte   5, 29
                !byte   5, 29
                !byte   5, 29
                !byte   5, 28
                !byte   5, 28
                !byte   4, 24
                !byte   4, 24
                !byte   4, 24
                !byte   4, 24
                !byte   4, 28
                !byte   4, 28
                !byte   4, 29
                !byte   4, 29
                !byte   4, 30
                !byte   4, 30
                !byte   5, 24
                !byte   5, 28
                !byte   5, 29
                !byte   6, 24
                !byte   6, 28
                !byte   6, 30
                !byte   7, 28
                !byte   7, 30
                !byte   8, 28
                !byte   8, 30
                !byte   9, 28
                !byte   9, 30
                !byte  10, 28
                !byte  10, 30
                !byte  11, 24
                !byte  11, 29
                !byte  11, 30
                !byte  12, 24
                !byte  12, 28
                !byte  12, 29
                !byte  12, 30
                !byte  13, 24
                !byte  13, 24
                !byte  13, 28
                !byte  13, 28
                !byte  13, 29
                !byte  13, 29
                !byte  13, 30
                !byte  13, 30
                !byte  13, 24
                !byte  12, 30
                !byte  12, 30
                !byte  12, 29
                !byte  12, 29
                !byte  12, 28
                !byte  12, 28
                !byte  12, 24
                !byte  12, 24
                !byte  11, 30
                !byte  11, 29
                !byte  11, 28
                !byte  10, 30
                !byte  10, 29
                !byte  10, 24
                !byte   9, 29
                !byte   9, 24
                !byte   8, 29
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 23
                !byte   8, 23
                !byte   8, 22
                !byte   8, 21
                !byte   8, 21
                !byte   8, 22
                !byte   8, 23
                !byte   8, 23
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 29
                !byte   8, 24
                !byte   7, 29
                !byte   7, 24
                !byte   6, 29
                !byte   6, 24
                !byte   5, 29
                !byte   5, 24
                !byte   4, 30
                !byte   4, 28
                !byte   4, 24
                !byte   3, 30
                !byte   3, 29
                !byte   3, 28
                !byte   3, 24
                !byte   2, 30
                !byte   2, 30
                !byte   2, 29
                !byte   2, 29
                !byte   2, 28
                !byte   2, 28
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 28
                !byte   1, 28
                !byte   1, 29
                !byte   1, 29
                !byte   1, 30
                !byte   1, 30
                !byte   2, 24
                !byte   2, 28
                !byte   2, 29
                !byte   3, 24
                !byte   3, 28
                !byte   3, 30
                !byte   4, 28
                !byte   4, 30
                !byte   5, 28
                !byte   5, 30
                !byte   6, 28
                !byte   6, 30
                !byte   7, 28
                !byte   7, 30
                !byte   8, 28
                !byte   8, 30
                !byte   9, 28
                !byte   9, 30
                !byte  10, 24
                !byte  10, 29
                !byte  10, 30
                !byte  11, 24
                !byte  11, 28
                !byte  11, 29
                !byte  11, 30
                !byte  12, 24
                !byte  12, 24
                !byte  13, 28
                !byte  13, 24
                !byte  14, 29
                !byte  14, 29
                !byte  14, 30
                !byte  14, 30
                !byte  14, 24
                !byte  13, 30
                !byte  13, 30
                !byte  13, 29
                !byte  13, 29
                !byte  13, 28
                !byte  13, 28
                !byte  13, 24
                !byte  13, 24
                !byte  12, 30
                !byte  12, 29
                !byte  12, 24
                !byte  11, 30
                !byte  11, 29
                !byte  11, 24
                !byte  10, 29
                !byte  10, 24
                !byte   9, 29
                !byte   9, 24
                !byte   8, 29
                !byte   8, 24
                !byte   7, 29
                !byte   7, 24
                !byte   6, 29
                !byte   6, 24
                !byte   5, 29
                !byte   5, 24
                !byte   4, 29
                !byte   4, 24
                !byte   3, 30
                !byte   3, 28
                !byte   3, 24
                !byte   2, 30
                !byte   2, 29
                !byte   2, 28
                !byte   2, 24
                !byte   1, 30
                !byte   1, 30
                !byte   1, 29
                !byte   1, 29
                !byte   1, 28
                !byte   1, 28
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 23
                !byte   1, 23
                !byte   1, 23
                !byte   1, 23
                !byte   1, 22
                !byte   1, 22
                !byte   1, 22
                !byte   1, 22
                !byte   1, 21
                !byte   1, 21
                !byte   1, 21
                !byte   1, 21
                !byte   1, 21
                !byte   2, 25
                !byte   2, 25
                !byte   2, 26
                !byte   2, 26
                !byte   2, 27
                !byte   2, 27
                !byte   3, 21
                !byte   4, 25
                !byte   4, 25
                !byte   4, 25
                !byte   4, 25
                !byte   4, 25
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 21
                !byte   4, 21
                !byte   4, 21
                !byte   4, 21
                !byte   5, 25
                !byte   5, 27
                !byte   6, 25
                !byte   6, 27
                !byte   7, 25
                !byte   7, 27
                !byte   8, 25
                !byte   8, 27
                !byte   9, 25
                !byte   9, 27
                !byte  10, 25
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  11, 25
                !byte  11, 27
                !byte  12, 25
                !byte  12, 27
                !byte  13, 25
                !byte  13, 27
                !byte  14, 21
                !byte  14, 26
                !byte  14, 27
                !byte  15, 21
                !byte  15, 25
                !byte  15, 26
                !byte  15, 27
                !byte  16, 21
                !byte  16, 25
                !byte  16, 26
                !byte  16, 27
                !byte  17, 21
                !byte  17, 25
                !byte  17, 26
                !byte  17, 27
                !byte  18, 21
                !byte  18, 25
                !byte  18, 26
                !byte  18, 27
                !byte  19, 21
                !byte  19, 25
                !byte  19, 26
                !byte  19, 27
                !byte  20, 27
                !byte  20, 26
                !byte  20, 25
                !byte  20, 21
                !byte  19, 27
                !byte  19, 26
                !byte  19, 25
                !byte  19, 21
                !byte  18, 27
                !byte  18, 26
                !byte  18, 25
                !byte  18, 21
                !byte  17, 27
                !byte  17, 26
                !byte  17, 25
                !byte  17, 21
                !byte  16, 27
                !byte  16, 26
                !byte  16, 25
                !byte  16, 21
                !byte  15, 27
                !byte  15, 26
                !byte  15, 25
                !byte  14, 27
                !byte  14, 26
                !byte  14, 21
                !byte  13, 26
                !byte  13, 21
                !byte  12, 26
                !byte  12, 21
                !byte  11, 26
                !byte  11, 21
                !byte  10, 26
                !byte  10, 21
                !byte   9, 26
                !byte   9, 21
                !byte   8, 27
                !byte   8, 25
                !byte   8, 21
                !byte   7, 27
                !byte   7, 26
                !byte   7, 25
                !byte   7, 21
                !byte   7, 25
                !byte   7, 25
                !byte   7, 26
                !byte   7, 26
                !byte   7, 26
                !byte   7, 27
                !byte   7, 27
                !byte   7, 27
                !byte   7, 27
                !byte   7, 26
                !byte   7, 25
                !byte   7, 21
                !byte   6, 27
                !byte   6, 26
                !byte   6, 25
                !byte   6, 21
                !byte   6, 25
                !byte   6, 26
                !byte   6, 27
                !byte   7, 21
                !byte   7, 25
                !byte   7, 26
                !byte   8, 21
                !byte   8, 25
                !byte   8, 27
                !byte   9, 25
                !byte   9, 27
                !byte EO_BIRDYANIMATIONTABLE    ;loop end

;from Bird #2 OK
;y-position, shape#
bird2YAnimationTable
bird2Y0
                !byte   0,  3
                !byte   0,  6
                !byte   1,  3
                !byte   1,  6
bird2Y2
                !byte   2,  3
                !byte   2,  5
                !byte   3,  3
                !byte   3,  4
bird2Y4
                !byte   4,  3
                !byte   4,  6
                !byte   5,  3
                !byte   5,  6
bird2Y6
                !byte   6,  3
                !byte   6,  6
                !byte   7,  3
                !byte   7,  3
bird2Y8
                !byte   8,  4
                !byte   8,  6
                !byte   9,  4
                !byte   9,  6
bird2Y10
                !byte  10,  3
                !byte  10,  6
                !byte  11,  3
                !byte  11,  4
                !byte  11,  6
bird2Y12
                !byte  12,  3
                !byte  12,  3
                !byte  12,  4
                !byte  12,  5
                !byte  12,  6
                !byte  12,  6
                !byte  13,  3
                !byte  13,  4
                !byte  13,  5
                !byte  13,  6
bird2Y14
                !byte  14,  3
                !byte  14,  4
                !byte  14,  6
                !byte  15,  3
                !byte  15,  4
                !byte  15,  5
                !byte  15,  6
bird2Y16
                !byte  16,  3
                !byte  16,  4
                !byte  16,  4
                !byte  16,  5
                !byte  16,  6
                !byte  16,  6
bird2Y17
                !byte  17,  3
                !byte  16,  6
                !byte  16,  6
                !byte  16,  5
                !byte  16,  8
                !byte  16,  8
                !byte  16,  7
                !byte  16,  7
                !byte  16,  7
                !byte  15, 10
                !byte  15,  9
                !byte  15,  8
                !byte  15,  7
                !byte  15,  7
                !byte  14, 10
                !byte  14,  9
                !byte  14,  7
                !byte  14,  7
                !byte  13, 10
                !byte  13,  8
                !byte  12, 10
                !byte  12, 10
                !byte  12,  8
                !byte  11, 10
                !byte  11,  8
                !byte  10, 10
                !byte  10,  8
                !byte  10,  8
                !byte   9, 10
                !byte   9,  8
                !byte   8, 10
                !byte   8,  8
                !byte   7, 10
                !byte   7,  8
                !byte   6, 10
                !byte   6,  8
                !byte   5, 10
                !byte   5,  8
                !byte   4, 10
                !byte   4,  8
                !byte   3, 10
                !byte   3, 12
                !byte   2, 14
                !byte   2, 12
                !byte   2, 11
                !byte   1, 14
                !byte   1, 12
                !byte   0, 14
                !byte   0, 12
                !byte  -1, 14
                !byte  -1, 12
                !byte  -2, 14
                !byte  -2, 14
                !byte  -3, 14
                !byte  -3, 14
                !byte  -3, 12
                !byte  -3, 12
                !byte  -3, 11
                !byte  -4, 14
                !byte  -4, 14
                !byte  -4, 13
                !byte  -4, 13
                !byte  -4, 12
                !byte  -4, 12
                !byte  -4, 12
                !byte  -4, 11
                !byte  -4, 11
                !byte  -4, 11
                !byte  -4, 11
                !byte  -4, 11
                !byte  -4, 11
                !byte  -3, 12
                !byte  -3, 12
                !byte  -3, 13
                !byte  -3, 13
                !byte  -3, 13
                !byte  -3, 14
                !byte  -3, 14
                !byte  -3, 14
                !byte  -2, 11
                !byte  -2, 12
                !byte  -2, 13
                !byte  -2, 14
                !byte  -2, 14
                !byte  -1, 11
                !byte  -1, 11
                !byte  -1, 11
                !byte  -1, 14
                !byte  -1, 14
                !byte   0, 11
                !byte   0, 13
                !byte   1, 11
                !byte   1, 11
                !byte   1, 14
                !byte   2, 11
                !byte   2, 11
                !byte   2, 13
                !byte   3, 11
                !byte   3, 14
                !byte   4, 11
                !byte   4, 11
                !byte   4, 13
                !byte   5, 11
                !byte   5, 14
                !byte   5, 14
                !byte   6, 11
                !byte   6, 11
                !byte   6, 13
                !byte   7, 11
                !byte   7, 14
                !byte   7, 14
                !byte   8, 11
                !byte   8, 13
                !byte   9, 11
                !byte   9, 14
                !byte   9, 14
                !byte  10, 11
                !byte  10, 11
                !byte  10, 13
                !byte  11, 11
                !byte  11, 12
                !byte  11, 12
                !byte  11, 14
                !byte  11, 14
                !byte  12, 11
                !byte  12, 13
                !byte  12, 14
                !byte  13, 11
                !byte  13, 12
                !byte  13, 14
                !byte  14, 12
                !byte  14, 13
                !byte  14, 14
                !byte  15, 11
                !byte  15, 13
                !byte  15, 14
                !byte  16, 11
                !byte  16, 16
                !byte  16, 16
                !byte  16, 17
                !byte  16, 17
                !byte  16, 18
                !byte  16, 19
                !byte  16, 19
                !byte  16, 20
                !byte  16, 21
                !byte  16, 21
                !byte  15, 27
                !byte  15, 26
                !byte  15, 25
                !byte  15, 21
                !byte  14, 27
                !byte  14, 26
                !byte  14, 21
                !byte  13, 27
                !byte  13, 25
                !byte  12, 27
                !byte  12, 25
                !byte  11, 27
                !byte  11, 25
                !byte  10, 27
                !byte  10, 25
bird2YAnimationLoopStart
                !byte   9, 27       ;loop start
                !byte   9, 25
                !byte   8, 27
                !byte   8, 25
                !byte   8, 21
                !byte   7, 26
                !byte   7, 25
                !byte   7, 21
                
                !byte   7, 22
                !byte   7, 23
                !byte   7, 24
                !byte   7, 24
                !byte   7, 23
                !byte   7, 22
                !byte   7, 21
                !byte   7, 21
                !byte   7, 22
                !byte   7, 23
                !byte   7, 24
                !byte   7, 24
                !byte   7, 23
                !byte   7, 22
                !byte   7, 21
                !byte   7, 21
                !byte   7, 22
                !byte   7, 23
                !byte   7, 24
                !byte   7, 24
                !byte   7, 23
                !byte   7, 22
                !byte   7, 21
                !byte   7, 21
                !byte   7, 22
                !byte   7, 23
                !byte   7, 24
                !byte   7, 24
                !byte   7, 23
                !byte   7, 22
                !byte   7, 21
                !byte   7, 21
                !byte   7, 22
                !byte   7, 23
                !byte   7, 24
                !byte   7, 24
                !byte   7, 23
                !byte   7, 22
                
                !byte   6, 27
                !byte   6, 26
                !byte   6, 25
                !byte   6, 21
                !byte   6, 25
                !byte   6, 26
                !byte   6, 27
                !byte   7, 21
                !byte   7, 25
                !byte   7, 26
                !byte   7, 27
                !byte   7, 27
                !byte   7, 27
                !byte   7, 27
                !byte   7, 26
                !byte   7, 26
                !byte   7, 26
                !byte   7, 25
                !byte   7, 25
                !byte   7, 21
                !byte   7, 25
                !byte   7, 26
                !byte   7, 27
                !byte   8, 21
                !byte   8, 25
                !byte   8, 27
                !byte   9, 21
                !byte   9, 26
                !byte  10, 21
                !byte  10, 26
                !byte  11, 21
                !byte  11, 26
                !byte  12, 21
                !byte  12, 26
                !byte  13, 21
                !byte  13, 26
                !byte  14, 21
                !byte  14, 26
                !byte  14, 27
                !byte  15, 25
                !byte  15, 26
                !byte  15, 27
                !byte  16, 21
                !byte  16, 25
                !byte  16, 26
                !byte  16, 27
                !byte  17, 21
                !byte  17, 25
                !byte  17, 26
                !byte  17, 27
                !byte  18, 21
                !byte  18, 25
                !byte  18, 26
                !byte  18, 27
                !byte  19, 21
                !byte  19, 25
                !byte  19, 26
                !byte  19, 27
                !byte  20, 21
                !byte  20, 25
                !byte  20, 26
                !byte  20, 27
                !byte  19, 27
                !byte  19, 26
                !byte  19, 25
                !byte  19, 21
                !byte  18, 27
                !byte  18, 26
                !byte  18, 25
                !byte  18, 21
                !byte  17, 27
                !byte  17, 26
                !byte  17, 25
                !byte  17, 21
                !byte  16, 27
                !byte  16, 26
                !byte  16, 25
                !byte  16, 21
                !byte  15, 27
                !byte  15, 26
                !byte  15, 25
                !byte  15, 21
                !byte  14, 27
                !byte  14, 26
                !byte  14, 21
                !byte  13, 27
                !byte  13, 25
                !byte  12, 27
                !byte  12, 25
                !byte  11, 27
                !byte  11, 25
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 25
                !byte   9, 27
                !byte   9, 25
                !byte   8, 27
                !byte   8, 25
                !byte   7, 27
                !byte   7, 25
                !byte   6, 27
                !byte   6, 25
                !byte   5, 27
                !byte   5, 25
                !byte   4, 21
                !byte   4, 21
                !byte   4, 21
                !byte   4, 21
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 25
                !byte   4, 25
                !byte   4, 25
                !byte   4, 25
                !byte   4, 25
                !byte   3, 21
                !byte   2, 27
                !byte   2, 27
                !byte   2, 26
                !byte   2, 26
                !byte   2, 25
                !byte   2, 25
                !byte   1, 21
                !byte   1, 21
                !byte   1, 21
                !byte   1, 21
                !byte   1, 21
                !byte   1, 22
                !byte   1, 22
                !byte   1, 22
                !byte   1, 22
                !byte   1, 23
                !byte   1, 23
                !byte   1, 23
                !byte   1, 23
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 28
                !byte   1, 28
                !byte   1, 29
                !byte   1, 29
                !byte   1, 30
                !byte   1, 30
                !byte   2, 24
                !byte   2, 28
                !byte   2, 29
                !byte   2, 30
                !byte   3, 24
                !byte   3, 28
                !byte   3, 30
                !byte   4, 24
                !byte   4, 29
                !byte   5, 24
                !byte   5, 29
                !byte   6, 24
                !byte   6, 29
                !byte   7, 24
                !byte   7, 29
                !byte   8, 24
                !byte   8, 29
                !byte   9, 24
                !byte   9, 29
                !byte  10, 24
                !byte  10, 29
                !byte  11, 24
                !byte  11, 29
                !byte  11, 30
                !byte  11, 30
                !byte  11, 29
                !byte  11, 28
                !byte  11, 24
                !byte  10, 30
                !byte  10, 29
                !byte  10, 24
                !byte   9, 30
                !byte   9, 28
                !byte   8, 30
                !byte   8, 28
                !byte   7, 30
                !byte   7, 28
                !byte   6, 30
                !byte   6, 28
                !byte   5, 30
                !byte   5, 28
                !byte   4, 30
                !byte   4, 28
                !byte   3, 30
                !byte   3, 28
                !byte   3, 24
                !byte   2, 29
                !byte   2, 28
                !byte   2, 24
                !byte   1, 30
                !byte   1, 30
                !byte   1, 29
                !byte   1, 29
                !byte   1, 28
                !byte   1, 28
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   2, 28
                !byte   2, 28
                !byte   2, 29
                !byte   2, 29
                !byte   2, 30
                !byte   2, 30
                !byte   3, 24
                !byte   3, 28
                !byte   3, 29
                !byte   3, 30
                !byte   4, 24
                !byte   4, 28
                !byte   4, 30
                !byte   5, 24
                !byte   5, 29
                !byte   6, 24
                !byte   6, 29
                !byte   7, 24
                !byte   7, 29
                !byte   8, 24
                !byte   8, 29
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 23
                !byte   8, 23
                !byte   8, 22
                !byte   8, 21
                !byte   8, 21
                !byte   8, 22
                !byte   8, 23
                !byte   8, 23
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 29
                !byte   9, 24
                !byte   9, 29
                !byte  10, 24
                !byte  10, 29
                !byte  10, 30
                !byte  11, 28
                !byte  11, 29
                !byte  11, 30
                !byte  12, 24
                !byte  12, 24
                !byte  12, 28
                !byte  12, 28
                !byte  12, 29
                !byte  12, 29
                !byte  12, 30
                !byte  12, 30
                !byte  13, 24
                !byte  13, 30
                !byte  13, 30
                !byte  13, 29
                !byte  13, 29
                !byte  13, 28
                !byte  13, 28
                !byte  13, 24
                !byte  13, 24
                !byte  12, 30
                !byte  12, 29
                !byte  12, 28
                !byte  12, 24
                !byte  11, 30
                !byte  11, 29
                !byte  11, 24
                !byte  10, 30
                !byte  10, 28
                !byte   9, 30
                !byte   9, 28
                !byte   8, 30
                !byte   8, 28
                !byte   7, 30
                !byte   7, 28
                !byte   6, 30
                !byte   6, 28
                !byte   6, 24
                !byte   5, 29
                !byte   5, 28
                !byte   5, 24
                !byte   4, 30
                !byte   4, 30
                !byte   4, 29
                !byte   4, 29
                !byte   4, 28
                !byte   4, 28
                !byte   4, 24
                !byte   4, 24
                !byte   4, 24
                !byte   4, 24
                !byte   5, 28
                !byte   5, 28
                !byte   5, 29
                !byte   5, 29
                !byte   5, 29
                !byte   5, 30
                !byte   5, 30
                !byte   6, 24
                !byte   6, 28
                !byte   6, 29
                !byte   6, 30
                !byte   7, 24
                !byte   7, 28
                !byte   7, 30
                !byte   8, 24
                !byte   8, 29
                !byte   9, 24
                !byte   9, 29
                !byte  10, 24
                !byte  10, 29
                !byte  11, 24
                !byte  11, 29
                !byte  12, 24
                !byte  12, 29
                !byte  13, 24
                !byte  13, 29
                !byte  14, 24
                !byte  14, 29
                !byte  15, 24
                !byte  15, 29
                !byte  15, 30
                !byte  16, 28
                !byte  16, 29
                !byte  16, 30
                !byte  16, 30
                !byte  16, 29
                !byte  16, 28
                !byte  16, 24
                !byte  15, 28
                !byte  15, 24
                !byte  14, 30
                !byte  14, 29
                !byte  14, 24
                !byte  14, 24
                !byte  14, 24
                !byte  14, 24
                !byte  14, 24
                !byte  14, 24
                !byte  14, 23
                !byte  14, 23
                !byte  14, 22
                !byte  14, 21
                !byte  14, 21
                !byte  14, 22
                !byte  14, 23
                !byte  14, 23
                !byte  14, 24
                !byte  14, 24
                !byte  14, 24
                !byte  14, 29
                !byte  13, 30
                !byte  13, 28
                !byte  12, 30
                !byte  12, 28
                !byte  11, 30
                !byte  11, 28
                !byte  10, 30
                !byte  10, 29
                !byte  10, 28
                !byte  10, 24
                !byte  10, 23
                !byte  10, 23
                !byte  10, 23
                !byte  10, 23
                !byte  10, 23
                !byte  10, 23
                !byte  10, 22
                !byte  10, 22
                !byte  10, 22
                !byte  10, 22
                !byte  10, 21
                !byte  10, 21
                !byte  10, 21
                !byte  10, 21
                !byte  10, 21
                !byte EO_BIRDYANIMATIONTABLE    ;loop end

;from Bird #3
;y-position, shape#
bird3YAnimationTable
bird3Y0
                !byte   0,  3
                !byte   0,  6
                !byte   1,  3
                !byte   1,  6
bird3Y2
                !byte   2,  3
                !byte   2,  5
                !byte   3,  3
                !byte   3,  4
bird3Y4
                !byte   4,  3
                !byte   4,  6
                !byte   5,  3
                !byte   5,  6
bird3Y6
                !byte   6,  3
                !byte   6,  6
                !byte   7,  3
                !byte   7,  3
bird3Y8
                !byte   8,  4
                !byte   8,  6
                !byte   9,  4
                !byte   9,  6
bird3Y10
                !byte  10,  3
                !byte  10,  6
                !byte  11,  3
                !byte  11,  4
                !byte  11,  6
bird3Y12
                !byte  12,  3
                !byte  12,  3
                !byte  12,  4
                !byte  12,  5
                !byte  12,  6
                !byte  12,  6
                !byte  13,  3
                !byte  13,  4
                !byte  13,  5
                !byte  13,  6
bird3Y14
                !byte  14,  3
                !byte  14,  4
                !byte  14,  6
                !byte  15,  3
                !byte  15,  4
                !byte  15,  5
                !byte  15,  6
bird3Y16
                !byte  16,  3
                !byte  16,  4
                !byte  16,  4
                !byte  16,  5
                !byte  16,  6
                !byte  16,  6
bird3Y17
                !byte  17,  3
                !byte  16,  6
                !byte  16,  6
                !byte  16,  5
                !byte  16,  8
                !byte  16,  8
                !byte  16,  7
                !byte  16,  7
                !byte  16,  7
                !byte  15, 10
                !byte  15,  9
                !byte  15,  8
                !byte  15,  7
                !byte  15,  7
                !byte  14, 10
                !byte  14,  9
                !byte  14,  7
                !byte  14,  7
                !byte  13, 10
                !byte  13,  8
                !byte  12, 10
                !byte  12, 10
                !byte  12,  8
                !byte  11, 10
                !byte  11,  8
                !byte  10, 10
                !byte  10,  8
                !byte  10,  8
                !byte   9, 10
                !byte   9,  8
                !byte   8, 10
                !byte   8,  8
                !byte   7, 10
                !byte   7,  8
                !byte   6, 10
                !byte   6,  8
                !byte   5, 10
                !byte   5,  8
                !byte   4, 10
                !byte   4,  8
                !byte   3, 10
                !byte   3, 12
                !byte   2, 14
                !byte   2, 12
                !byte   2, 11
                !byte   1, 14
                !byte   1, 12
                !byte   0, 14
                !byte   0, 12
                !byte  -1, 14
                !byte  -1, 12
                !byte  -2, 14
                !byte  -2, 14
                !byte  -3, 14
                !byte  -3, 14
                !byte  -3, 12
                !byte  -3, 12
                !byte  -3, 11
                !byte  -4, 14
                !byte  -4, 14
                !byte  -4, 13
                !byte  -4, 13
                !byte  -4, 12
                !byte  -4, 12
                !byte  -4, 12
                !byte  -4, 11
                !byte  -4, 11
                !byte  -4, 11
                !byte  -4, 11
                !byte  -4, 11
                !byte  -4, 11
                !byte  -3, 12
                !byte  -3, 12
                !byte  -3, 13
                !byte  -3, 13
                !byte  -3, 13
                !byte  -3, 14
                !byte  -3, 14
                !byte  -3, 14
                !byte  -2, 11
                !byte  -2, 12
                !byte  -2, 13
                !byte  -2, 14
                !byte  -2, 14
                !byte  -1, 11
                !byte  -1, 11
                !byte  -1, 11
                !byte  -1, 14
                !byte  -1, 14
                !byte   0, 11
                !byte   0, 13
                !byte   1, 11
                !byte   1, 11
                !byte   1, 14
                !byte   2, 11
                !byte   2, 11
                !byte   2, 13
                !byte   3, 11
                !byte   3, 14
                !byte   4, 11
                !byte   4, 11
                !byte   4, 13
                !byte   5, 11
                !byte   5, 14
                !byte   5, 14
                !byte   6, 11
                !byte   6, 11
                !byte   6, 13
                !byte   7, 11
                !byte   7, 14
                !byte   7, 14
                !byte   8, 11
                !byte   8, 13
                !byte   9, 11
                !byte   9, 14
                !byte   9, 14
                !byte  10, 11
                !byte  10, 11
                !byte  10, 13
                !byte  11, 11
                !byte  11, 12
                !byte  11, 12
                !byte  11, 14
                !byte  11, 14
                !byte  12, 11
                !byte  12, 13
                !byte  12, 14
                !byte  13, 11
                !byte  13, 12
                !byte  13, 14
                !byte  14, 12
                !byte  14, 13
                !byte  14, 14
                !byte  15, 11
                !byte  15, 13
                !byte  15, 14
                !byte  16, 11
                !byte  16, 16
                !byte  16, 16
                !byte  16, 17
                !byte  16, 17
                !byte  16, 18
                !byte  16, 19
                !byte  16, 19
                !byte  16, 20
                !byte  16, 21
                !byte  16, 21
                !byte  15, 27
                !byte  15, 26
                !byte  15, 25
                !byte  15, 21
                !byte  14, 27
                !byte  14, 26
                !byte  14, 21
                !byte  13, 27
                !byte  13, 25
                !byte  12, 27
                !byte  12, 25
                !byte  11, 27
                !byte  11, 25
                !byte  10, 27
                !byte  10, 25
bird3YAnimationLoopStart
                !byte   9, 27       ;loop start
                !byte   9, 25
                !byte   8, 27
                !byte   8, 25
                !byte   8, 21
                !byte   7, 26
                !byte   7, 25
                !byte   7, 21
                !byte   6, 27
                !byte   6, 26
                !byte   6, 25
                !byte   6, 21
                !byte   6, 25
                !byte   6, 26
                !byte   6, 27
                !byte   7, 21
                !byte   7, 25
                !byte   7, 26
                !byte   7, 27
                !byte   7, 27
                !byte   7, 27
                !byte   7, 27
                !byte   7, 26
                !byte   7, 26
                !byte   7, 26
                !byte   7, 25
                !byte   7, 25
                !byte   7, 21
                !byte   7, 25
                !byte   7, 26
                !byte   7, 27
                !byte   8, 21
                !byte   8, 25
                !byte   8, 27
                !byte   9, 21
                !byte   9, 26
                !byte  10, 21
                !byte  10, 26
                !byte  11, 21
                !byte  11, 26
                !byte  12, 21
                !byte  12, 26
                !byte  13, 21
                !byte  13, 26
                !byte  14, 21
                !byte  14, 26
                !byte  14, 27
                !byte  15, 25
                !byte  15, 26
                !byte  15, 27
                !byte  16, 21
                !byte  16, 25
                !byte  16, 26
                !byte  16, 27
                !byte  17, 21
                !byte  17, 25
                !byte  17, 26
                !byte  17, 27
                !byte  18, 21
                !byte  18, 25
                !byte  18, 26
                !byte  18, 27
                !byte  19, 21
                !byte  19, 25
                !byte  19, 26
                !byte  19, 27
                !byte  20, 21
                !byte  20, 25
                !byte  20, 26
                !byte  20, 27
                !byte  19, 27
                !byte  19, 26
                !byte  19, 25
                !byte  19, 21
                !byte  18, 27
                !byte  18, 26
                !byte  18, 25
                !byte  18, 21
                !byte  17, 27
                !byte  17, 26
                !byte  17, 25
                !byte  17, 21
                !byte  16, 27
                !byte  16, 26
                !byte  16, 25
                !byte  16, 21
                !byte  15, 27
                !byte  15, 26
                !byte  15, 25
                !byte  15, 21
                !byte  14, 27
                !byte  14, 26
                !byte  14, 21
                !byte  13, 27
                !byte  13, 25
                !byte  12, 27
                !byte  12, 25
                !byte  11, 27
                !byte  11, 25
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 25
                !byte   9, 27
                !byte   9, 25
                !byte   8, 27
                !byte   8, 25
                !byte   7, 27
                !byte   7, 25
                !byte   6, 27
                !byte   6, 25
                !byte   5, 27
                !byte   5, 25
                !byte   4, 21
                !byte   4, 21
                !byte   4, 21
                !byte   4, 21
                !byte   4, 22
                !byte   4, 23
                !byte   4, 24
                !byte   4, 24
                !byte   4, 23
                !byte   4, 22
                !byte   4, 21
                !byte   4, 21
                !byte   4, 22
                !byte   4, 23
                !byte   4, 24
                !byte   4, 24
                !byte   4, 23
                !byte   4, 22
                !byte   4, 21
                !byte   4, 21
                !byte   4, 22
                !byte   4, 23
                !byte   4, 24
                !byte   4, 24
                !byte   4, 23
                !byte   4, 22
                !byte   4, 21
                !byte   4, 21
                !byte   4, 22
                !byte   4, 23
                !byte   4, 24
                !byte   4, 24
                !byte   4, 23
                !byte   4, 22
                !byte   4, 21
                !byte   4, 21
                !byte   4, 22
                !byte   4, 23
                !byte   4, 24
                !byte   4, 24
                !byte   4, 23
                !byte   4, 22
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 25
                !byte   4, 25
                !byte   4, 25
                !byte   4, 25
                !byte   4, 25
                !byte   3, 21
                !byte   3, 20
                !byte   3, 19
                !byte   3, 18
                !byte   3, 17
                !byte   3, 16
                !byte   3, 15
                !byte   3, 14
                !byte   3, 13
                !byte   3, 12
                !byte   3, 11
                !byte   3, 10
                !byte   3, 09
                !byte   3, 08
                !byte   3, 07
                !byte   3, 08
                !byte   3, 09
                !byte   3, 10
                !byte   3, 11
                !byte   3, 12
                !byte   3, 13
                !byte   3, 14
                !byte   3, 15
                !byte   3, 16
                !byte   3, 17
                !byte   3, 18
                !byte   3, 19
                !byte   3, 20
                !byte   3, 21
                !byte   2, 27
                !byte   2, 27
                !byte   2, 26
                !byte   2, 26
                !byte   2, 25
                !byte   2, 25
                !byte   1, 21
                !byte   1, 21
                !byte   1, 21
                !byte   1, 21
                !byte   1, 21
                !byte   1, 22
                !byte   1, 22
                !byte   1, 22
                !byte   1, 22
                !byte   1, 23
                !byte   1, 23
                !byte   1, 23
                !byte   1, 23
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 28
                !byte   1, 28
                !byte   1, 29
                !byte   1, 29
                !byte   1, 30
                !byte   1, 30
                !byte   2, 24
                !byte   2, 28
                !byte   2, 29
                !byte   2, 30
                !byte   3, 24
                !byte   3, 28
                !byte   3, 30
                !byte   4, 24
                !byte   4, 29
                !byte   5, 24
                !byte   5, 29
                !byte   6, 24
                !byte   6, 29
                !byte   7, 24
                !byte   7, 29
                !byte   8, 24
                !byte   8, 29
                !byte   9, 24
                !byte   9, 29
                !byte  10, 24
                !byte  10, 29
                !byte  11, 24
                !byte  11, 29
                !byte  11, 30
                !byte  12, 24
                !byte  12, 29
                !byte  12, 30
                !byte  13, 24
                !byte  13, 24
                !byte  13, 28
                !byte  13, 28
                !byte  13, 29
                !byte  13, 29
                !byte  13, 30
                !byte  13, 30
                !byte  14, 24
                !byte  14, 30
                !byte  14, 30
                !byte  14, 29
                !byte  14, 29
                !byte  13, 24
                !byte  13, 28
                !byte  12, 24
                !byte  12, 24
                !byte  11, 30
                !byte  11, 29
                !byte  11, 28
                !byte  11, 24
                !byte  10, 30
                !byte  10, 29
                !byte  10, 24
                !byte   9, 30
                !byte   9, 28
                !byte   8, 30
                !byte   8, 28
                !byte   7, 30
                !byte   7, 28
                !byte   6, 30
                !byte   6, 28
                !byte   5, 30
                !byte   5, 28
                !byte   4, 30
                !byte   4, 28
                !byte   3, 30
                !byte   3, 28
                !byte   3, 24
                !byte   2, 29
                !byte   2, 28
                !byte   2, 24
                !byte   1, 30
                !byte   1, 30
                !byte   1, 29
                !byte   1, 29
                !byte   1, 28
                !byte   1, 28
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   2, 28
                !byte   2, 28
                !byte   2, 29
                !byte   2, 29
                !byte   2, 30
                !byte   2, 30
                !byte   3, 24
                !byte   3, 28
                !byte   3, 29
                !byte   3, 30
                !byte   4, 24
                !byte   4, 28
                !byte   4, 30
                !byte   5, 24
                !byte   5, 29
                !byte   6, 24
                !byte   6, 29
                !byte   7, 24
                !byte   7, 29
                !byte   8, 24
                !byte   8, 29
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 23
                !byte   8, 23
                !byte   8, 22
                !byte   8, 21
                !byte   8, 21
                !byte   8, 22
                !byte   8, 23
                !byte   8, 23
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 29
                !byte   9, 24
                !byte   9, 29
                !byte  10, 24
                !byte  10, 29
                !byte  10, 30
                !byte  11, 28
                !byte  11, 29
                !byte  11, 30
                !byte  12, 24
                !byte  12, 24
                !byte  12, 28
                !byte  12, 28
                !byte  12, 29
                !byte  12, 29
                !byte  12, 30
                !byte  12, 30
                !byte  13, 24
                !byte  13, 30
                !byte  13, 30
                !byte  13, 29
                !byte  13, 29
                !byte  13, 28
                !byte  13, 28
                !byte  13, 24
                !byte  13, 24
                !byte  12, 30
                !byte  12, 29
                !byte  12, 28
                !byte  12, 24
                !byte  11, 30
                !byte  11, 29
                !byte  11, 24
                !byte  10, 30
                !byte  10, 28
                !byte   9, 30
                !byte   9, 28
                !byte   8, 30
                !byte   8, 28
                !byte   7, 30
                !byte   7, 28
                !byte   6, 30
                !byte   6, 28
                !byte   6, 24
                !byte   5, 29
                !byte   5, 28
                !byte   5, 24
                !byte   4, 30
                !byte   4, 30
                !byte   4, 29
                !byte   4, 29
                !byte   4, 28
                !byte   4, 28
                !byte   4, 24
                !byte   4, 24
                !byte   4, 24
                !byte   4, 24
                !byte   5, 28
                !byte   5, 28
                !byte   5, 29
                !byte   5, 29
                !byte   5, 29
                !byte   5, 30
                !byte   5, 30
                !byte   6, 24
                !byte   6, 28
                !byte   6, 29
                !byte   6, 30
                !byte   7, 24
                !byte   7, 28
                !byte   7, 30
                !byte   8, 24
                !byte   8, 29
                !byte   9, 24
                !byte   9, 29
                !byte  10, 24
                !byte  10, 29
                !byte  11, 24
                !byte  11, 29
                !byte  12, 24
                !byte  12, 29
                !byte  12, 30
                !byte  12, 28
                !byte  11, 30
                !byte  11, 28
                !byte  10, 30
                !byte  10, 29
                !byte  10, 28
                !byte  10, 24
                !byte  10, 23
                !byte  10, 23
                !byte  10, 23
                !byte  10, 23
                !byte  10, 23
                !byte  10, 23
                !byte  10, 22
                !byte  10, 22
                !byte  10, 22
                !byte  10, 22
                !byte  10, 21
                !byte  10, 21
                !byte  10, 21
                !byte  10, 21
                !byte  10, 21
                !byte EO_BIRDYANIMATIONTABLE    ;loop end

;from Bird #4
;y-position, shape#
bird4YAnimationTable
bird4Y0
                !byte   0,  3
                !byte   0,  6
                !byte   1,  3
                !byte   1,  6
bird4Y2
                !byte   2,  3
                !byte   2,  5
                !byte   3,  3
                !byte   3,  4
bird4Y4
                !byte   4,  3
                !byte   4,  6
                !byte   5,  3
                !byte   5,  6
bird4Y6
                !byte   6,  3
                !byte   6,  6
                !byte   7,  3
                !byte   7,  3
bird4Y8
                !byte   8,  4
                !byte   8,  6
                !byte   9,  4
                !byte   9,  6
bird4Y10
                !byte  10,  3
                !byte  10,  6
                !byte  11,  3
                !byte  11,  4
                !byte  11,  6
bird4Y12
                !byte  12,  3
                !byte  12,  3
                !byte  12,  4
                !byte  12,  5
                !byte  12,  6
                !byte  12,  6
                !byte  13,  3
                !byte  13,  4
                !byte  13,  5
                !byte  13,  6
bird4Y14
                !byte  14,  3
                !byte  14,  4
                !byte  14,  6
                !byte  15,  3
                !byte  15,  4
                !byte  15,  5
                !byte  15,  6
bird4Y16
                !byte  16,  3
                !byte  16,  4
                !byte  16,  4
                !byte  16,  5
                !byte  16,  6
                !byte  16,  6
bird4Y17
                !byte  17,  3
                !byte  16,  6
                !byte  16,  6
                !byte  16,  5
                !byte  16,  8
                !byte  16,  8
                !byte  16,  7
                !byte  16,  7
                !byte  16,  7
                !byte  15, 10
                !byte  15,  9
                !byte  15,  8
                !byte  15,  7
                !byte  15,  7
                !byte  14, 10
                !byte  14,  9
                !byte  14,  7
                !byte  14,  7
                !byte  13, 10
                !byte  13,  8
                !byte  12, 10
                !byte  12, 10
                !byte  12,  8
                !byte  11, 10
                !byte  11,  8
                !byte  10, 10
                !byte  10,  8
                !byte  10,  8
                !byte   9, 10
                !byte   9,  8
                !byte   8, 10
                !byte   8,  8
                !byte   7, 10
                !byte   7,  8
                !byte   6, 10
                !byte   6,  8
                !byte   5, 10
                !byte   5,  8
                !byte   4, 10
                !byte   4,  8
                !byte   3, 10
                !byte   3, 12
                !byte   2, 14
                !byte   2, 12
                !byte   2, 11
                !byte   1, 14
                !byte   1, 12
                !byte   0, 14
                !byte   0, 12
                !byte  -1, 14
                !byte  -1, 12
                !byte  -2, 14
                !byte  -2, 14
                !byte  -3, 14
                !byte  -3, 14
                !byte  -3, 12
                !byte  -3, 12
                !byte  -3, 11
                !byte  -4, 14
                !byte  -4, 14
                !byte  -4, 13
                !byte  -4, 13
                !byte  -4, 12
                !byte  -4, 12
                !byte  -4, 12
                !byte  -4, 11
                !byte  -4, 11
                !byte  -4, 11
                !byte  -4, 11
                !byte  -4, 11
                !byte  -4, 11
                !byte  -3, 12
                !byte  -3, 12
                !byte  -3, 13
                !byte  -3, 13
                !byte  -3, 13
                !byte  -3, 14
                !byte  -3, 14
                !byte  -3, 14
                !byte  -2, 11
                !byte  -2, 12
                !byte  -2, 13
                !byte  -2, 14
                !byte  -2, 14
                !byte  -1, 11
                !byte  -1, 11
                !byte  -1, 11
                !byte  -1, 14
                !byte  -1, 14
                !byte   0, 11
                !byte   0, 13
                !byte   1, 11
                !byte   1, 11
                !byte   1, 14
                !byte   2, 11
                !byte   2, 11
                !byte   2, 13
                !byte   3, 11
                !byte   3, 14
                !byte   4, 11
                !byte   4, 11
                !byte   4, 13
                !byte   5, 11
                !byte   5, 14
                !byte   5, 14
                !byte   6, 11
                !byte   6, 11
                !byte   6, 13
                !byte   7, 11
                !byte   7, 14
                !byte   7, 14
                !byte   8, 11
                !byte   8, 13
                !byte   9, 11
                !byte   9, 14
                !byte   9, 14
                !byte  10, 11
                !byte  10, 11
                !byte  10, 13
                !byte  11, 11
                !byte  11, 12
                !byte  11, 12
                !byte  11, 14
                !byte  11, 14
                !byte  12, 11
                !byte  12, 13
                !byte  12, 14
                !byte  13, 11
                !byte  13, 12
                !byte  13, 14
                !byte  14, 12
                !byte  14, 13
                !byte  14, 14
                !byte  15, 11
                !byte  15, 13
                !byte  15, 14
                !byte  16, 11
                !byte  16, 16
                !byte  16, 16
                !byte  16, 17
                !byte  16, 17
                !byte  16, 18
                !byte  16, 19
                !byte  16, 19
                !byte  16, 20
                !byte  16, 21
                !byte  16, 21
                !byte  15, 27
                !byte  15, 26
                !byte  15, 25
                !byte  15, 21
                !byte  14, 27
                !byte  14, 26
                !byte  14, 21
                !byte  13, 27
                !byte  13, 25
                !byte  12, 27
                !byte  12, 25
                !byte  11, 27
                !byte  11, 25
                !byte  10, 27
                !byte  10, 25
bird4YAnimationLoopStart
                !byte   9, 27       ;loop start
                !byte   9, 25
                !byte   8, 27
                !byte   8, 25
                !byte   8, 21
                !byte   7, 26
                !byte   7, 25
                !byte   7, 21
                !byte   6, 27
                !byte   6, 26
                !byte   6, 25
                !byte   6, 21
                !byte   6, 25
                !byte   6, 26
                !byte   6, 27
                !byte   7, 21
                !byte   7, 25
                !byte   7, 26
                !byte   7, 27
                !byte   7, 27
                !byte   7, 27
                !byte   7, 27
                !byte   7, 26
                !byte   7, 26
                !byte   7, 26
                !byte   7, 25
                !byte   7, 25
                !byte   7, 21
                !byte   7, 25
                !byte   7, 26
                !byte   7, 27
                !byte   8, 21
                !byte   8, 25
                !byte   8, 27
                !byte   9, 21
                !byte   9, 26
                !byte  10, 21
                !byte  10, 26
                !byte  11, 21
                !byte  11, 26
                !byte  11, 27
                !byte  11, 25
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 25
                !byte   9, 27
                !byte   9, 25
                !byte   8, 27
                !byte   8, 25
                !byte   7, 27
                !byte   7, 25
                !byte   6, 27
                !byte   6, 25
                !byte   5, 27
                !byte   5, 25
                !byte   4, 21
                !byte   4, 21
                !byte   4, 21
                !byte   4, 21
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 25
                !byte   4, 25
                !byte   4, 25
                !byte   4, 25
                !byte   4, 25
                !byte   3, 21
                !byte   2, 27
                !byte   2, 27
                !byte   2, 26
                !byte   2, 26
                !byte   2, 25
                !byte   2, 25
                !byte   1, 21
                !byte   1, 21
                !byte   1, 21
                !byte   1, 21
                !byte   1, 21
                !byte   1, 22
                !byte   1, 22
                !byte   1, 22
                !byte   1, 22
                !byte   1, 23
                !byte   1, 23
                !byte   1, 23
                !byte   1, 23
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 28
                !byte   1, 28
                !byte   1, 29
                !byte   1, 29
                !byte   1, 30
                !byte   1, 30
                !byte   2, 24
                !byte   2, 28
                !byte   2, 29
                !byte   2, 30
                !byte   3, 24
                !byte   3, 28
                !byte   3, 30
                !byte   4, 24
                !byte   4, 29
                !byte   5, 24
                !byte   5, 29
                !byte   6, 24
                !byte   6, 29
                !byte   7, 24
                !byte   7, 29
                !byte   8, 24
                !byte   8, 29
                !byte   9, 24
                !byte   9, 29
                !byte  10, 24
                !byte  10, 29
                !byte  11, 24
                !byte  11, 29
                !byte  11, 30
                !byte  12, 24
                !byte  12, 29
                !byte  12, 30
                !byte  13, 24
                !byte  13, 24
                !byte  13, 28
                !byte  13, 28
                !byte  13, 29
                !byte  13, 29
                !byte  13, 30
                !byte  13, 30
                !byte  14, 24
                !byte  14, 30
                !byte  14, 30
                !byte  14, 29
                !byte  14, 29
                !byte  13, 24
                !byte  13, 28
                !byte  12, 24
                !byte  12, 24
                !byte  11, 30
                !byte  11, 29
                !byte  11, 28
                !byte  11, 24
                !byte  10, 30
                !byte  10, 29
                !byte  10, 24
                !byte   9, 30
                !byte   9, 28
                !byte   8, 30
                !byte   8, 28
                !byte   7, 30
                !byte   7, 28
                !byte   6, 30
                !byte   6, 28
                !byte   5, 30
                !byte   5, 28
                !byte   4, 30
                !byte   4, 28
                !byte   3, 30
                !byte   3, 28
                !byte   3, 24
                !byte   2, 29
                !byte   2, 28
                !byte   2, 24
                !byte   1, 30
                !byte   1, 30
                !byte   1, 29
                !byte   1, 29
                !byte   1, 28
                !byte   1, 28
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   2, 28
                !byte   2, 28
                !byte   2, 29
                !byte   2, 29
                !byte   2, 30
                !byte   2, 30
                !byte   3, 24
                !byte   3, 28
                !byte   3, 29
                !byte   3, 30
                !byte   4, 24
                !byte   4, 28
                !byte   4, 30
                !byte   5, 24
                !byte   5, 29
                !byte   6, 24
                !byte   6, 29
                !byte   7, 24
                !byte   7, 29
                !byte   8, 24
                !byte   8, 29
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 23
                !byte   8, 23
                !byte   8, 22
                !byte   8, 21
                !byte   8, 21
                !byte   8, 22
                !byte   8, 23
                !byte   8, 23
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 29
                !byte   9, 24
                !byte   9, 29
                !byte  10, 24
                !byte  10, 29
                !byte  10, 30
                !byte  11, 28
                !byte  11, 29
                !byte  11, 30
                !byte  12, 24
                !byte  12, 24
                !byte  12, 28
                !byte  12, 28
                !byte  12, 29
                !byte  12, 29
                !byte  12, 30
                !byte  12, 30
                !byte  13, 24
                !byte  13, 30
                !byte  13, 30
                !byte  13, 29
                !byte  13, 29
                !byte  13, 28
                !byte  13, 28
                !byte  13, 24
                !byte  13, 24
                !byte  12, 30
                !byte  12, 29
                !byte  12, 28
                !byte  12, 24
                !byte  11, 30
                !byte  11, 29
                !byte  11, 24
                !byte  10, 30
                !byte  10, 28
                !byte   9, 30
                !byte   9, 28
                !byte   8, 30
                !byte   8, 28
                !byte   7, 30
                !byte   7, 28
                !byte   6, 30
                !byte   6, 28
                !byte   6, 24
                !byte   5, 29
                !byte   5, 28
                !byte   5, 24
                !byte   4, 30
                !byte   4, 30
                !byte   4, 29
                !byte   4, 29
                !byte   4, 28
                !byte   4, 28
                !byte   4, 24
                !byte   4, 24
                !byte   4, 24
                !byte   4, 24
                !byte   5, 28
                !byte   5, 28
                !byte   5, 29
                !byte   5, 29
                !byte   5, 29
                !byte   5, 30
                !byte   5, 30
                !byte   6, 24
                !byte   6, 28
                !byte   6, 29
                !byte   6, 30
                !byte   7, 24
                !byte   7, 28
                !byte   7, 30
                !byte   8, 24
                !byte   8, 29
                !byte   9, 24
                !byte   9, 29
                !byte  10, 24
                !byte  10, 29
                !byte  11, 24
                !byte  11, 29
                !byte  12, 24
                !byte  12, 29
                !byte  13, 24
                !byte  13, 29
                !byte  14, 24
                !byte  14, 29
                !byte  14, 30
                !byte  14, 29
                !byte  14, 24
                !byte  14, 24
                !byte  14, 24
                !byte  14, 24
                !byte  14, 24
                !byte  14, 24
                !byte  14, 23
                !byte  14, 23
                !byte  14, 22
                !byte  14, 21
                !byte  14, 21
                !byte  14, 22
                !byte  14, 23
                !byte  14, 23
                !byte  14, 24
                !byte  14, 24
                !byte  14, 24
                !byte  14, 29
                !byte  13, 30
                !byte  13, 28
                !byte  12, 30
                !byte  12, 28
                !byte  11, 30
                !byte  11, 28
                !byte  10, 30
                !byte  10, 29
                !byte  10, 28
                !byte  10, 24
                !byte  10, 23
                !byte  10, 23
                !byte  10, 23
                !byte  10, 23
                !byte  10, 23
                !byte  10, 23
                !byte  10, 22
                !byte  10, 22
                !byte  10, 22
                !byte  10, 22
                !byte  10, 21
                
                !byte  10, 22
                !byte  10, 23
                !byte  10, 24
                !byte  10, 24
                !byte  10, 23
                !byte  10, 22
                !byte  10, 21
                !byte  10, 21
                !byte  10, 22
                !byte  10, 23
                !byte  10, 24
                !byte  10, 24
                !byte  10, 23
                !byte  10, 22
                !byte  10, 21
                !byte  10, 21
                !byte  10, 22
                !byte  10, 23
                !byte  10, 24
                !byte  10, 24
                !byte  10, 23
                !byte  10, 22
                !byte  10, 21
                !byte  10, 21
                !byte  10, 22
                !byte  10, 23
                !byte  10, 24
                !byte  10, 24
                !byte  10, 23
                !byte  10, 22
                !byte  10, 21
                !byte  10, 21
                !byte  10, 22
                !byte  10, 23
                !byte  10, 24
                !byte  10, 24
                !byte  10, 23
                !byte  10, 22
                
                !byte  10, 21
                !byte  10, 21
                !byte  10, 21
                !byte  10, 21
                !byte EO_BIRDYANIMATIONTABLE    ;loop end

;from Bird #5
;y-position, shape#
bird5YAnimationTable
bird5Y0
                !byte   0,  3
                !byte   0,  6
                !byte   1,  3
                !byte   1,  6
bird5Y2
                !byte   2,  3
                !byte   2,  5
                !byte   3,  3
                !byte   3,  4
bird5Y4
                !byte   4,  3
                !byte   4,  6
                !byte   5,  3
                !byte   5,  6
bird5Y6
                !byte   6,  3
                !byte   6,  6
                !byte   7,  3
                !byte   7,  3
bird5Y8
                !byte   8,  4
                !byte   8,  6
                !byte   9,  4
                !byte   9,  6
bird5Y10
                !byte  10,  3
                !byte  10,  6
                !byte  11,  3
                !byte  11,  4
                !byte  11,  6
bird5Y12
                !byte  12,  3
                !byte  12,  3
                !byte  12,  4
                !byte  12,  5
                !byte  12,  6
                !byte  12,  6
                !byte  13,  3
                !byte  13,  4
                !byte  13,  5
                !byte  13,  6
bird5Y14
                !byte  14,  3
                !byte  14,  4
                !byte  14,  6
                !byte  15,  3
                !byte  15,  4
                !byte  15,  5
                !byte  15,  6
bird5Y16
                !byte  16,  3
                !byte  16,  4
                !byte  16,  4
                !byte  16,  5
                !byte  16,  6
                !byte  16,  6
bird5Y17
                !byte  17,  3
                !byte  16,  6
                !byte  16,  6
                !byte  16,  5
                !byte  16,  8
                !byte  16,  8
                !byte  16,  7
                !byte  16,  7
                !byte  16,  7
                !byte  15, 10
                !byte  15,  9
                !byte  15,  8
                !byte  15,  7
                !byte  15,  7
                !byte  14, 10
                !byte  14,  9
                !byte  14,  7
                !byte  14,  7
                !byte  13, 10
                !byte  13,  8
                !byte  12, 10
                !byte  12, 10
                !byte  12,  8
                !byte  11, 10
                !byte  11,  8
                !byte  10, 10
                !byte  10,  8
                !byte  10,  8
                !byte   9, 10
                !byte   9,  8
                !byte   8, 10
                !byte   8,  8
                !byte   7, 10
                !byte   7,  8
                !byte   6, 10
                !byte   6,  8
                !byte   5, 10
                !byte   5,  8
                !byte   4, 10
                !byte   4,  8
                !byte   3, 10
                !byte   3, 12
                !byte   2, 14
                !byte   2, 12
                !byte   2, 11
                !byte   1, 14
                !byte   1, 12
                !byte   0, 14
                !byte   0, 12
                !byte  -1, 14
                !byte  -1, 12
                !byte  -2, 14
                !byte  -2, 14
                !byte  -3, 14
                !byte  -3, 14
                !byte  -3, 12
                !byte  -3, 12
                !byte  -3, 11
                !byte  -4, 14
                !byte  -4, 14
                !byte  -4, 13
                !byte  -4, 13
                !byte  -4, 12
                !byte  -4, 12
                !byte  -4, 12
                !byte  -4, 11
                !byte  -4, 11
                !byte  -4, 11
                !byte  -4, 11
                !byte  -4, 11
                !byte  -4, 11
                !byte  -3, 12
                !byte  -3, 12
                !byte  -3, 13
                !byte  -3, 13
                !byte  -3, 13
                !byte  -3, 14
                !byte  -3, 14
                !byte  -3, 14
                !byte  -2, 11
                !byte  -2, 12
                !byte  -2, 13
                !byte  -2, 14
                !byte  -2, 14
                !byte  -1, 11
                !byte  -1, 11
                !byte  -1, 11
                !byte  -1, 14
                !byte  -1, 14
                !byte   0, 11
                !byte   0, 13
                !byte   1, 11
                !byte   1, 11
                !byte   1, 14
                !byte   2, 11
                !byte   2, 11
                !byte   2, 13
                !byte   3, 11
                !byte   3, 14
                !byte   4, 11
                !byte   4, 11
                !byte   4, 13
                !byte   5, 11
                !byte   5, 14
                !byte   5, 14
                !byte   6, 11
                !byte   6, 11
                !byte   6, 13
                !byte   7, 11
                !byte   7, 14
                !byte   7, 14
                !byte   8, 11
                !byte   8, 13
                !byte   9, 11
                !byte   9, 14
                !byte   9, 14
                !byte  10, 11
                !byte  10, 11
                !byte  10, 13
                !byte  11, 11
                !byte  11, 12
                !byte  11, 12
                !byte  11, 14
                !byte  11, 14
                !byte  12, 11
                !byte  12, 13
                !byte  12, 14
                !byte  13, 11
                !byte  13, 12
                !byte  13, 14
                !byte  14, 12
                !byte  14, 13
                !byte  14, 14
                !byte  15, 11
                !byte  15, 13
                !byte  15, 14
                !byte  16, 11
                !byte  16, 16
                !byte  16, 16
                !byte  16, 17
                !byte  16, 17
                !byte  16, 18
                !byte  16, 19
                !byte  16, 19
                !byte  16, 20
                !byte  16, 21
                !byte  16, 21
                !byte  15, 27
                !byte  15, 26
                !byte  15, 25
                !byte  15, 21
                !byte  14, 27
                !byte  14, 26
                !byte  14, 21
                !byte  13, 27
                !byte  13, 25
                !byte  12, 27
                !byte  12, 25
                !byte  11, 27
                !byte  11, 25
                !byte  10, 27
                !byte  10, 25
bird5YAnimationLoopStart
                !byte   9, 27       ;loop start
                !byte   9, 25
                !byte   9, 21
                !byte   9, 26
                !byte  10, 21
                !byte  10, 26
                !byte  11, 21
                !byte  11, 26
                !byte  12, 21
                !byte  12, 26
                !byte  13, 21
                
                !byte  13, 22
                !byte  13, 23
                !byte  13, 24
                !byte  13, 24
                !byte  13, 23
                !byte  13, 22
                !byte  13, 21
                !byte  13, 21
                !byte  13, 22
                !byte  13, 23
                !byte  13, 24
                !byte  13, 24
                !byte  13, 23
                !byte  13, 22
                !byte  13, 21
                !byte  13, 21
                !byte  13, 22
                !byte  13, 23
                !byte  13, 24
                !byte  13, 24
                !byte  13, 23
                !byte  13, 22
                !byte  13, 21
                !byte  13, 21
                !byte  13, 22
                !byte  13, 23
                !byte  13, 24
                !byte  13, 24
                !byte  13, 23
                !byte  13, 22
                !byte  13, 21
                !byte  13, 21
                !byte  13, 22
                !byte  13, 23
                !byte  13, 24
                !byte  13, 24
                !byte  13, 23
                !byte  13, 22
                
                !byte  13, 26
                !byte  14, 21
                !byte  14, 26
                !byte  14, 27
                !byte  15, 25
                !byte  15, 26
                !byte  15, 27
                !byte  16, 21
                !byte  16, 25
                !byte  16, 26
                !byte  16, 27
                !byte  17, 21
                !byte  17, 25
                !byte  17, 26
                !byte  17, 27
                !byte  18, 21
                !byte  18, 25
                !byte  18, 26
                !byte  18, 27
                !byte  19, 21
                !byte  19, 25
                !byte  19, 26
                !byte  19, 27
                !byte  20, 21
                !byte  20, 25
                !byte  20, 26
                !byte  20, 27
                !byte  19, 27
                !byte  19, 26
                !byte  19, 25
                !byte  19, 21
                !byte  18, 27
                !byte  18, 26
                !byte  18, 25
                !byte  18, 21
                !byte  17, 27
                !byte  17, 26
                !byte  17, 25
                !byte  17, 21
                !byte  16, 27
                !byte  16, 26
                !byte  16, 25
                !byte  16, 21
                !byte  15, 27
                !byte  15, 26
                !byte  15, 25
                !byte  15, 21
                !byte  14, 27
                !byte  14, 26
                !byte  14, 21
                !byte  13, 27
                !byte  13, 25
                !byte  12, 27
                !byte  12, 25
                !byte  11, 27
                !byte  11, 25
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 25
                !byte   9, 27
                !byte   9, 25
                !byte   8, 27
                !byte   8, 25
                !byte   7, 27
                !byte   7, 25
                !byte   6, 27
                !byte   6, 25
                !byte   5, 27
                !byte   5, 25
                !byte   5, 24
                !byte   5, 29
                !byte   6, 24
                !byte   6, 29
                !byte   7, 24
                !byte   7, 29
                !byte   8, 24
                !byte   8, 29
                !byte   9, 24
                !byte   9, 29
                !byte  10, 24
                !byte  10, 29
                !byte  11, 24
                !byte  11, 29
                !byte  11, 30
                !byte  12, 24
                !byte  12, 29
                !byte  12, 30
                !byte  13, 24
                !byte  13, 24
                !byte  13, 28
                !byte  13, 28
                !byte  13, 29
                !byte  13, 29
                !byte  13, 30
                !byte  13, 30
                !byte  14, 24
                !byte  14, 30
                !byte  14, 30
                !byte  14, 29
                !byte  14, 29
                !byte  13, 24
                !byte  13, 28
                !byte  12, 24
                !byte  12, 24
                !byte  11, 30
                !byte  11, 29
                !byte  11, 28
                !byte  11, 24
                !byte  10, 30
                !byte  10, 29
                !byte  10, 24
                !byte   9, 30
                !byte   9, 28
                !byte   8, 30
                !byte   8, 28
                !byte   7, 30
                !byte   7, 28
                !byte   6, 30
                !byte   6, 28
                !byte   5, 30
                !byte   5, 28
                !byte   4, 30
                !byte   4, 28
                !byte   3, 30
                !byte   3, 28
                !byte   3, 24
                !byte   2, 29
                !byte   2, 28
                !byte   2, 24
                !byte   1, 30
                !byte   1, 30
                !byte   1, 29
                !byte   1, 29
                !byte   1, 28
                !byte   1, 28
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   2, 28
                !byte   2, 28
                !byte   2, 29
                !byte   2, 29
                !byte   2, 30
                !byte   2, 30
                !byte   3, 24
                !byte   3, 28
                !byte   3, 29
                !byte   3, 30
                !byte   4, 24
                !byte   4, 28
                !byte   4, 30
                !byte   5, 24
                !byte   5, 29
                !byte   6, 24
                !byte   6, 29
                !byte   7, 24
                !byte   7, 29
                !byte   8, 24
                !byte   8, 29
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 23
                !byte   8, 23
                !byte   8, 22
                !byte   8, 21
                !byte   8, 21
                !byte   8, 22
                !byte   8, 23
                !byte   8, 23
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 29
                !byte   9, 24
                !byte   9, 29
                !byte  10, 24
                !byte  10, 29
                !byte  10, 30
                !byte  11, 28
                !byte  11, 29
                !byte  11, 30
                !byte  12, 24
                !byte  12, 24
                !byte  12, 28
                !byte  12, 28
                !byte  12, 29
                !byte  12, 29
                !byte  12, 30
                !byte  12, 30
                !byte  13, 24
                !byte  13, 30
                !byte  13, 30
                !byte  13, 29
                !byte  13, 29
                !byte  13, 28
                !byte  13, 28
                !byte  13, 24
                !byte  13, 24
                !byte  12, 30
                !byte  12, 29
                !byte  12, 28
                !byte  12, 24
                !byte  11, 30
                !byte  11, 29
                !byte  11, 24
                !byte  10, 30
                !byte  10, 28
                !byte   9, 30
                !byte   9, 28
                !byte   8, 30
                !byte   8, 28
                !byte   7, 30
                !byte   7, 28
                !byte   6, 30
                !byte   6, 28
                !byte   6, 24
                !byte   5, 29
                !byte   5, 28
                !byte   5, 24
                !byte   4, 30
                !byte   4, 30
                !byte   4, 29
                !byte   4, 29
                !byte   4, 28
                !byte   4, 28
                !byte   4, 24
                !byte   4, 24
                !byte   4, 24
                !byte   4, 24
                !byte   5, 28
                !byte   5, 28
                !byte   5, 29
                !byte   5, 29
                !byte   5, 29
                !byte   5, 30
                !byte   5, 30
                !byte   6, 24
                !byte   6, 28
                !byte   6, 29
                !byte   6, 30
                !byte   7, 24
                !byte   7, 28
                !byte   7, 30
                !byte   8, 24
                !byte   8, 29
                !byte   9, 24
                !byte   9, 29
                !byte  10, 24
                !byte  10, 29
                !byte  11, 24
                !byte  11, 29
                !byte  12, 24
                !byte  12, 29
                !byte  13, 24
                !byte  13, 29
                !byte  14, 24
                !byte  14, 29
                !byte  15, 24
                !byte  15, 29
                !byte  15, 30
                !byte  16, 28
                !byte  16, 29
                !byte  16, 30
                !byte  17, 24
                !byte  17, 24
                !byte  17, 24
                !byte  17, 24
                !byte  17, 24
                !byte  17, 23
                !byte  17, 23
                !byte  17, 22
                !byte  17, 21
                !byte  17, 21
                !byte  17, 22
                !byte  17, 23
                !byte  17, 23
                !byte  17, 24
                !byte  17, 24
                !byte  17, 24
                !byte  17, 24
                !byte  17, 24
                !byte  17, 28
                !byte  17, 28
                !byte  17, 29
                !byte  17, 29
                !byte  17, 30
                !byte  17, 30
                !byte  18, 24
                !byte  17, 30
                !byte  17, 30
                !byte  17, 29
                !byte  17, 29
                !byte  17, 28
                !byte  17, 28
                !byte  17, 24
                !byte  17, 24
                !byte  16, 30
                !byte  16, 29
                !byte  16, 28
                !byte  16, 24
                !byte  15, 28
                !byte  15, 24
                !byte  14, 30
                !byte  14, 29
                !byte  14, 24
                !byte  14, 24
                !byte  14, 24
                !byte  14, 24
                !byte  14, 24
                !byte  14, 24
                !byte  14, 23
                !byte  14, 23
                !byte  14, 22
                !byte  14, 21
                !byte  14, 21
                !byte  14, 22
                !byte  14, 23
                !byte  14, 23
                !byte  14, 24
                !byte  14, 24
                !byte  14, 24
                !byte  14, 29
                !byte  13, 30
                !byte  13, 28
                !byte  12, 30
                !byte  12, 28
                !byte  11, 30
                !byte  11, 28
                !byte  10, 30
                !byte  10, 29
                !byte  10, 28
                !byte  10, 24
                !byte  10, 23
                !byte  10, 23
                !byte  10, 23
                !byte  10, 23
                !byte  10, 23
                !byte  10, 23
                !byte  10, 22
                !byte  10, 22
                !byte  10, 22
                !byte  10, 22
                !byte  10, 21
                !byte  10, 21
                !byte  10, 21
                !byte  10, 21
                !byte  10, 21
                !byte EO_BIRDYANIMATIONTABLE    ;loop end

;from Bird #6
;y-position, shape#
bird6YAnimationTable
bird6Y0
                !byte   0,  3
                !byte   0,  6
                !byte   1,  3
                !byte   1,  6
bird6Y2
                !byte   2,  3
                !byte   2,  5
                !byte   3,  3
                !byte   3,  4
bird6Y4
                !byte   4,  3
                !byte   4,  6
                !byte   5,  3
                !byte   5,  6
bird6Y6
                !byte   6,  3
                !byte   6,  6
                !byte   7,  3
                !byte   7,  3
bird6Y8
                !byte   8,  4
                !byte   8,  6
                !byte   9,  4
                !byte   9,  6
bird6Y10
                !byte  10,  3
                !byte  10,  6
                !byte  11,  3
                !byte  11,  4
                !byte  11,  6
bird6Y12
                !byte  12,  3
                !byte  12,  3
                !byte  12,  4
                !byte  12,  5
                !byte  12,  6
                !byte  12,  6
                !byte  13,  3
                !byte  13,  4
                !byte  13,  5
                !byte  13,  6
bird6Y14
                !byte  14,  3
                !byte  14,  4
                !byte  14,  6
                !byte  15,  3
                !byte  15,  4
                !byte  15,  5
                !byte  15,  6
bird6Y16
                !byte  16,  3
                !byte  16,  4
                !byte  16,  4
                !byte  16,  5
                !byte  16,  6
                !byte  16,  6
bird6Y17
                !byte  17,  3
                !byte  16,  6
                !byte  16,  6
                !byte  16,  5
                !byte  16,  8
                !byte  16,  8
                !byte  16,  7
                !byte  16,  7
                !byte  16,  7
                !byte  15, 10
                !byte  15,  9
                !byte  15,  8
                !byte  15,  7
                !byte  15,  7
                !byte  14, 10
                !byte  14,  9
                !byte  14,  7
                !byte  14,  7
                !byte  13, 10
                !byte  13,  8
                !byte  12, 10
                !byte  12, 10
                !byte  12,  8
                !byte  11, 10
                !byte  11,  8
                !byte  10, 10
                !byte  10,  8
                !byte  10,  8
                !byte   9, 10
                !byte   9,  8
                !byte   8, 10
                !byte   8,  8
                !byte   7, 10
                !byte   7,  8
                !byte   6, 10
                !byte   6,  8
                !byte   5, 10
                !byte   5,  8
                !byte   4, 10
                !byte   4,  8
                !byte   3, 10
                !byte   3, 12
                !byte   2, 14
                !byte   2, 12
                !byte   2, 11
                !byte   1, 14
                !byte   1, 12
                !byte   0, 14
                !byte   0, 12
                !byte  -1, 14
                !byte  -1, 12
                !byte  -2, 14
                !byte  -2, 14
                !byte  -3, 14
                !byte  -3, 14
                !byte  -3, 12
                !byte  -3, 12
                !byte  -3, 11
                !byte  -4, 14
                !byte  -4, 14
                !byte  -4, 13
                !byte  -4, 13
                !byte  -4, 12
                !byte  -4, 12
                !byte  -4, 12
                !byte  -4, 11
                !byte  -4, 11
                !byte  -4, 11
                !byte  -4, 11
                !byte  -4, 11
                !byte  -4, 11
                !byte  -3, 12
                !byte  -3, 12
                !byte  -3, 13
                !byte  -3, 13
                !byte  -3, 13
                !byte  -3, 14
                !byte  -3, 14
                !byte  -3, 14
                !byte  -2, 11
                !byte  -2, 12
                !byte  -2, 13
                !byte  -2, 14
                !byte  -2, 14
                !byte  -1, 11
                !byte  -1, 11
                !byte  -1, 11
                !byte  -1, 14
                !byte  -1, 14
                !byte   0, 11
                !byte   0, 13
                !byte   1, 11
                !byte   1, 11
                !byte   1, 14
                !byte   2, 11
                !byte   2, 11
                !byte   2, 13
                !byte   3, 11
                !byte   3, 14
                !byte   4, 11
                !byte   4, 11
                !byte   4, 13
                !byte   5, 11
                !byte   5, 14
                !byte   5, 14
                !byte   6, 11
                !byte   6, 11
                !byte   6, 13
                !byte   7, 11
                !byte   7, 14
                !byte   7, 14
                !byte   8, 11
                !byte   8, 13
                !byte   9, 11
                !byte   9, 14
                !byte   9, 14
                !byte  10, 11
                !byte  10, 11
                !byte  10, 13
                !byte  11, 11
                !byte  11, 12
                !byte  11, 12
                !byte  11, 14
                !byte  11, 14
                !byte  12, 11
                !byte  12, 13
                !byte  12, 14
                !byte  13, 11
                !byte  13, 12
                !byte  13, 14
                !byte  14, 12
                !byte  14, 13
                !byte  14, 14
                !byte  15, 11
                !byte  15, 13
                !byte  15, 14
                !byte  16, 11
                !byte  16, 16
                !byte  16, 16
                !byte  16, 17
                !byte  16, 17
                !byte  16, 18
                !byte  16, 19
                !byte  16, 19
                !byte  16, 20
                !byte  16, 21
                !byte  16, 21
                !byte  15, 27
                !byte  15, 26
                !byte  15, 25
                !byte  15, 21
                !byte  14, 27
                !byte  14, 26
                !byte  14, 21
                !byte  13, 27
                !byte  13, 25
                !byte  12, 27
                !byte  12, 25
                !byte  11, 27
                !byte  11, 25
                !byte  10, 27
                !byte  10, 25
bird6YAnimationLoopStart
                !byte   9, 27       ;loop start
                !byte   9, 25
                !byte   8, 27
                !byte   8, 25
                !byte   8, 21
                !byte   7, 26
                !byte   7, 25
                !byte   7, 21
                !byte   6, 27
                !byte   6, 26
                !byte   6, 25
                !byte   6, 21
                !byte   6, 25
                !byte   6, 26
                !byte   6, 27
                !byte   7, 21
                !byte   7, 25
                !byte   7, 26
                !byte   7, 27
                !byte   7, 27
                !byte   7, 27
                !byte   7, 27
                !byte   7, 26
                !byte   7, 26
                !byte   7, 26
                !byte   7, 25
                !byte   7, 25
                !byte   7, 21
                !byte   7, 25
                !byte   7, 26
                !byte   7, 27
                !byte   8, 21
                !byte   8, 25
                !byte   8, 27
                !byte   9, 21
                !byte   9, 26
                !byte  10, 21
                !byte  10, 26
                !byte  11, 21
                !byte  11, 26
                !byte  12, 21
                !byte  12, 26
                !byte  13, 21
                !byte  13, 26
                !byte  14, 21
                !byte  14, 26
                !byte  14, 27
                !byte  15, 25
                !byte  15, 26
                !byte  15, 27
                !byte  16, 21
                !byte  16, 25
                !byte  16, 26
                !byte  16, 27
                !byte  17, 21
                !byte  17, 25
                !byte  17, 26
                !byte  17, 27
                !byte  18, 21
                !byte  18, 25
                !byte  18, 26
                !byte  18, 27
                !byte  19, 21
                !byte  19, 25
                !byte  19, 26
                !byte  19, 27
                !byte  20, 21
                !byte  20, 25
                !byte  20, 26
                !byte  20, 27
                !byte  19, 27
                !byte  19, 26
                !byte  19, 25
                !byte  19, 21
                !byte  18, 27
                !byte  18, 26
                !byte  18, 25
                !byte  18, 21
                !byte  17, 27
                !byte  17, 26
                !byte  17, 25
                !byte  17, 21
                !byte  16, 27
                !byte  16, 26
                !byte  16, 25
                !byte  16, 21
                !byte  15, 27
                !byte  15, 26
                !byte  15, 25
                !byte  15, 21
                !byte  14, 27
                !byte  14, 26
                !byte  14, 21
                !byte  13, 27
                !byte  13, 25
                !byte  12, 27
                !byte  12, 25
                !byte  11, 27
                !byte  11, 25
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 25
                !byte   9, 27
                !byte   9, 25
                !byte   8, 27
                !byte   8, 25
                !byte   7, 27
                !byte   7, 25
                !byte   6, 27
                !byte   6, 25
                !byte   5, 27
                !byte   5, 25
                !byte   4, 21
                !byte   4, 21
                !byte   4, 21
                !byte   4, 21
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 25
                !byte   4, 25
                !byte   4, 25
                !byte   4, 25
                !byte   4, 25
                !byte   3, 21
                !byte   2, 27
                !byte   2, 27
                !byte   2, 26
                !byte   2, 26
                !byte   2, 25
                !byte   2, 25
                !byte   1, 21
                !byte   1, 21
                !byte   1, 21
                !byte   1, 21
                !byte   1, 21
                !byte   1, 22
                !byte   1, 22
                !byte   1, 22
                !byte   1, 22
                !byte   1, 23
                !byte   1, 23
                !byte   1, 23
                !byte   1, 23
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 28
                !byte   1, 28
                !byte   1, 29
                !byte   1, 29
                !byte   1, 30
                !byte   1, 30
                !byte   2, 24
                !byte   2, 28
                !byte   2, 29
                !byte   2, 30
                !byte   3, 24
                !byte   3, 28
                !byte   3, 30
                !byte   4, 24
                !byte   4, 29
                !byte   5, 24
                !byte   5, 29
                !byte   6, 24
                !byte   6, 29
                !byte   7, 24
                !byte   7, 29
                !byte   8, 24
                !byte   8, 29
                !byte   9, 24
                !byte   9, 29
                !byte  10, 24
                !byte  10, 29
                !byte  11, 24
                !byte  11, 29
                !byte  11, 30
                !byte  12, 24
                !byte  12, 29
                !byte  12, 30
                !byte  13, 24
                !byte  13, 24
                !byte  13, 28
                !byte  13, 28
                !byte  13, 29
                !byte  13, 29
                !byte  13, 30
                !byte  13, 30
                !byte  14, 24
                !byte  14, 30
                !byte  14, 30
                !byte  14, 29
                !byte  14, 29
                !byte  13, 24
                !byte  13, 28
                !byte  12, 24
                !byte  12, 24
                !byte  11, 30
                !byte  11, 29
                !byte  11, 28
                !byte  11, 24
                !byte  10, 30
                !byte  10, 29
                !byte  10, 24
                !byte   9, 30
                !byte   9, 28
                !byte   8, 30
                !byte   8, 28
                !byte   7, 30
                !byte   7, 28
                !byte   6, 30
                !byte   6, 28
                !byte   5, 30
                !byte   5, 28
                !byte   4, 30
                !byte   4, 28
                !byte   3, 30
                !byte   3, 28
                !byte   3, 24
                !byte   2, 29
                !byte   2, 28
                !byte   2, 24
                !byte   1, 30
                !byte   1, 30
                !byte   1, 29
                !byte   1, 29
                !byte   1, 28
                !byte   1, 28
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   2, 28
                !byte   2, 28
                !byte   2, 29
                !byte   2, 29
                !byte   2, 30
                !byte   2, 30
                !byte   3, 24
                !byte   3, 28
                !byte   3, 29
                !byte   3, 30
                !byte   4, 24
                !byte   4, 28
                !byte   4, 30
                !byte   5, 24
                !byte   5, 29
                !byte   6, 24
                !byte   6, 29
                !byte   7, 24
                !byte   7, 29
                !byte   8, 24
                !byte   8, 29
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 23
                !byte   8, 23
                !byte   8, 22
                !byte   8, 21
                !byte   8, 21
                !byte   8, 22
                !byte   8, 23
                !byte   8, 23
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 29
                !byte   9, 24
                !byte   9, 29
                !byte  10, 24
                !byte  10, 29
                !byte  10, 30
                !byte  11, 28
                !byte  11, 29
                !byte  11, 30
                !byte  12, 24
                !byte  12, 24
                !byte  12, 28
                !byte  12, 28
                !byte  12, 29
                !byte  12, 29
                !byte  12, 30
                !byte  12, 30
                !byte  13, 24
                !byte  13, 30
                !byte  13, 30
                !byte  13, 29
                !byte  13, 29
                !byte  13, 28
                !byte  13, 28
                !byte  13, 24
                !byte  13, 24
                !byte  12, 30
                !byte  12, 29
                !byte  12, 28
                !byte  12, 24
                !byte  11, 30
                !byte  11, 29
                !byte  11, 24
                !byte  10, 30
                !byte  10, 28
                !byte   9, 30
                !byte   9, 28
                !byte   8, 30
                !byte   8, 28
                !byte   7, 30
                !byte   7, 28
                !byte   6, 30
                !byte   6, 28
                !byte   6, 24
                !byte   5, 29
                !byte   5, 28
                !byte   5, 24
                !byte   4, 30
                !byte   4, 30
                !byte   4, 29
                !byte   4, 29
                !byte   4, 28
                !byte   4, 28
                !byte   4, 24
                !byte   4, 24
                !byte   4, 24
                !byte   4, 24
                !byte   5, 28
                !byte   5, 28
                !byte   5, 29
                !byte   5, 29
                !byte   5, 29
                !byte   5, 30
                !byte   5, 30
                !byte   6, 24
                !byte   6, 28
                !byte   6, 29
                !byte   6, 30
                !byte   7, 24
                !byte   7, 28
                !byte   7, 30
                !byte   8, 24
                !byte   8, 29
                !byte   9, 24
                !byte   9, 29
                !byte  10, 24
                !byte  10, 29
                !byte  11, 24
                !byte  11, 29
                !byte  12, 24
                !byte  12, 29
                !byte  13, 24
                !byte  13, 29
                !byte  14, 24
                !byte  14, 29
                !byte  15, 24
                !byte  15, 29
                !byte  15, 30
                !byte  16, 28
                !byte  16, 29
                !byte  16, 30
                !byte  17, 24
                !byte  17, 24
                !byte  17, 24
                !byte  17, 24
                !byte  17, 24
                !byte  17, 23
                !byte  17, 23
                !byte  17, 22
                !byte  17, 21
                !byte  17, 21
                !byte  17, 22
                !byte  17, 23
                !byte  17, 23
                !byte  17, 24
                !byte  17, 24
                !byte  17, 24
                !byte  17, 24
                !byte  17, 24
                !byte  17, 28
                !byte  17, 28
                !byte  17, 29
                !byte  17, 29
                !byte  17, 30
                !byte  17, 30
                !byte  18, 24
                !byte  17, 30
                !byte  17, 30
                !byte  17, 29
                !byte  17, 29
                !byte  17, 28
                !byte  17, 28
                !byte  17, 24
                !byte  17, 24
                !byte  16, 30
                !byte  16, 29
                !byte  16, 28
                !byte  16, 24
                !byte  15, 28
                !byte  15, 24
                !byte  14, 30
                !byte  14, 29
                !byte  14, 24
                !byte  14, 24
                !byte  14, 24
                !byte  14, 24
                !byte  14, 24
                !byte  14, 24
                !byte  14, 23
                !byte  14, 23
                !byte  14, 22
                !byte  14, 21
                !byte  14, 21
                !byte  14, 22
                !byte  14, 23
                !byte  14, 23
                !byte  14, 24
                !byte  14, 24
                !byte  14, 24
                !byte  14, 29
                !byte  13, 30
                !byte  13, 28
                !byte  12, 30
                !byte  12, 28
                !byte  11, 30
                !byte  11, 28
                !byte  10, 30
                !byte  10, 29
                !byte  10, 28
                !byte  10, 24
                !byte  10, 23
                !byte  10, 23
                !byte  10, 23
                !byte  10, 23
                !byte  10, 23
                !byte  10, 23
                !byte  10, 22
                !byte  10, 22
                !byte  10, 22
                !byte  10, 22
                !byte  10, 21
                !byte  10, 21
                !byte  10, 21
                !byte  10, 21
                !byte  10, 21
                !byte EO_BIRDYANIMATIONTABLE    ;loop end

;from Bird #7
;y-position, shape#
bird7YAnimationTable
bird7Y0
                !byte   0,  3
                !byte   0,  6
                !byte   1,  3
                !byte   1,  6
bird7Y2
                !byte   2,  3
                !byte   2,  5
                !byte   3,  3
                !byte   3,  4
bird7Y4
                !byte   4,  3
                !byte   4,  6
                !byte   5,  3
                !byte   5,  6
bird7Y6
                !byte   6,  3
                !byte   6,  6
                !byte   7,  3
                !byte   7,  3
bird7Y8
                !byte   8,  4
                !byte   8,  6
                !byte   9,  4
                !byte   9,  6
bird7Y10
                !byte  10,  3
                !byte  10,  6
                !byte  11,  3
                !byte  11,  4
                !byte  11,  6
bird7Y12
                !byte  12,  3
                !byte  12,  3
                !byte  12,  4
                !byte  12,  5
                !byte  12,  6
                !byte  12,  6
                !byte  13,  3
                !byte  13,  4
                !byte  13,  5
                !byte  13,  6
bird7Y14
                !byte  14,  3
                !byte  14,  4
                !byte  14,  6
                !byte  15,  3
                !byte  15,  4
                !byte  15,  5
                !byte  15,  6
bird7Y16
                !byte  16,  3
                !byte  16,  4
                !byte  16,  4
                !byte  16,  5
                !byte  16,  6
                !byte  16,  6
bird7Y17
                !byte  17,  3
                !byte  16,  6
                !byte  16,  6
                !byte  16,  5
                !byte  16,  8
                !byte  16,  8
                !byte  16,  7
                !byte  16,  7
                !byte  16,  7
                !byte  15, 10
                !byte  15,  9
                !byte  15,  8
                !byte  15,  7
                !byte  15,  7
                !byte  14, 10
                !byte  14,  9
                !byte  14,  7
                !byte  14,  7
                !byte  13, 10
                !byte  13,  8
                !byte  12, 10
                !byte  12, 10
                !byte  12,  8
                !byte  11, 10
                !byte  11,  8
                !byte  10, 10
                !byte  10,  8
                !byte  10,  8
                !byte   9, 10
                !byte   9,  8
                !byte   8, 10
                !byte   8,  8
                !byte   7, 10
                !byte   7,  8
                !byte   6, 10
                !byte   6,  8
                !byte   5, 10
                !byte   5,  8
                !byte   4, 10
                !byte   4,  8
                !byte   3, 10
                !byte   3, 12
                !byte   2, 14
                !byte   2, 12
                !byte   2, 11
                !byte   1, 14
                !byte   1, 12
                !byte   0, 14
                !byte   0, 12
                !byte  -1, 14
                !byte  -1, 12
                !byte  -2, 14
                !byte  -2, 14
                !byte  -3, 14
                !byte  -3, 14
                !byte  -3, 12
                !byte  -3, 12
                !byte  -3, 11
                !byte  -4, 14
                !byte  -4, 14
                !byte  -4, 13
                !byte  -4, 13
                !byte  -4, 12
                !byte  -4, 12
                !byte  -4, 12
                !byte  -4, 11
                !byte  -4, 11
                !byte  -4, 11
                !byte  -4, 11
                !byte  -4, 11
                !byte  -4, 11
                !byte  -3, 12
                !byte  -3, 12
                !byte  -3, 13
                !byte  -3, 13
                !byte  -3, 13
                !byte  -3, 14
                !byte  -3, 14
                !byte  -3, 14
                !byte  -2, 11
                !byte  -2, 12
                !byte  -2, 13
                !byte  -2, 14
                !byte  -2, 14
                !byte  -1, 11
                !byte  -1, 11
                !byte  -1, 11
                !byte  -1, 14
                !byte  -1, 14
                !byte   0, 11
                !byte   0, 13
                !byte   1, 11
                !byte   1, 11
                !byte   1, 14
                !byte   2, 11
                !byte   2, 11
                !byte   2, 13
                !byte   3, 11
                !byte   3, 14
                !byte   4, 11
                !byte   4, 11
                !byte   4, 13
                !byte   5, 11
                !byte   5, 14
                !byte   5, 14
                !byte   6, 11
                !byte   6, 11
                !byte   6, 13
                !byte   7, 11
                !byte   7, 14
                !byte   7, 14
                !byte   8, 11
                !byte   8, 13
                !byte   9, 11
                !byte   9, 14
                !byte   9, 14
                !byte  10, 11
                !byte  10, 11
                !byte  10, 13
                !byte  11, 11
                !byte  11, 12
                !byte  11, 12
                !byte  11, 14
                !byte  11, 14
                !byte  12, 11
                !byte  12, 13
                !byte  12, 14
                !byte  13, 11
                !byte  13, 12
                !byte  13, 14
                !byte  14, 12
                !byte  14, 13
                !byte  14, 14
                !byte  15, 11
                !byte  15, 13
                !byte  15, 14
                !byte  16, 11
                !byte  16, 16
                !byte  16, 16
                !byte  16, 17
                !byte  16, 17
                !byte  16, 18
                !byte  16, 19
                !byte  16, 19
                !byte  16, 20
                !byte  16, 21
                !byte  16, 21
                !byte  15, 27
                !byte  15, 26
                !byte  15, 25
                !byte  15, 21
                !byte  14, 27
                !byte  14, 26
                !byte  14, 21
                !byte  13, 27
                !byte  13, 25
                !byte  12, 27
                !byte  12, 25
                !byte  11, 27
                !byte  11, 25
                !byte  10, 27
                !byte  10, 25
bird7YAnimationLoopStart
                !byte   9, 27       ;loop start
                !byte   9, 25
                !byte   8, 27
                !byte   8, 25
                !byte   8, 21
                !byte   7, 26
                !byte   7, 25
                !byte   7, 21
                !byte   6, 27
                !byte   6, 26
                !byte   6, 25
                !byte   6, 21
                !byte   6, 25
                !byte   6, 26
                !byte   6, 27
                !byte   7, 21
                !byte   7, 25
                !byte   7, 26
                !byte   7, 27
                !byte   7, 27
                !byte   7, 27
                !byte   7, 27
                !byte   7, 26
                !byte   7, 26
                !byte   7, 26
                !byte   7, 25
                !byte   7, 25
                !byte   7, 21
                !byte   7, 25
                !byte   7, 26
                !byte   7, 27
                !byte   8, 21
                !byte   8, 25
                !byte   8, 27
                !byte   9, 21
                !byte   9, 26
                !byte  10, 21
                !byte  10, 26
                !byte  11, 21
                !byte  11, 26
                !byte  12, 21
                !byte  12, 26
                !byte  13, 21
                !byte  13, 26
                !byte  14, 21
                !byte  14, 26
                !byte  14, 27
                !byte  15, 25
                !byte  15, 26
                !byte  15, 27
                !byte  16, 21
                
                !byte  16, 22
                !byte  16, 23
                !byte  16, 24
                !byte  16, 24
                !byte  16, 23
                !byte  16, 22
                !byte  16, 21
                !byte  16, 21
                !byte  16, 22
                !byte  16, 23
                !byte  16, 24
                !byte  16, 24
                !byte  16, 23
                !byte  16, 22
                !byte  16, 21
                !byte  16, 21
                !byte  16, 22
                !byte  16, 23
                !byte  16, 24
                !byte  16, 24
                !byte  16, 23
                !byte  16, 22
                !byte  16, 21
                !byte  16, 21
                !byte  16, 22
                !byte  16, 23
                !byte  16, 24
                !byte  16, 24
                !byte  16, 23
                !byte  16, 22
                !byte  16, 21
                !byte  16, 21
                !byte  16, 22
                !byte  16, 23
                !byte  16, 24
                !byte  16, 24
                !byte  16, 23
                !byte  16, 22
                
                !byte  16, 25
                !byte  16, 26
                !byte  16, 27
                !byte  16, 27
                !byte  16, 26
                !byte  16, 25
                !byte  16, 21
                !byte  15, 27
                !byte  15, 26
                !byte  15, 25
                !byte  15, 21
                !byte  14, 27
                !byte  14, 26
                !byte  14, 21
                !byte  13, 27
                !byte  13, 25
                !byte  12, 27
                !byte  12, 25
                !byte  11, 27
                !byte  11, 25
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 25
                !byte   9, 27
                !byte   9, 25
                !byte   8, 27
                !byte   8, 25
                !byte   7, 27
                !byte   7, 25
                !byte   6, 27
                !byte   6, 25
                !byte   5, 27
                !byte   5, 25
                !byte   4, 21
                !byte   4, 21
                !byte   4, 21
                !byte   4, 21
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 25
                !byte   4, 25
                !byte   4, 25
                !byte   4, 25
                !byte   4, 25
                !byte   3, 21
                !byte   3, 24
                !byte   3, 28
                !byte   3, 30
                !byte   4, 24
                !byte   4, 29
                !byte   5, 24
                !byte   5, 29
                !byte   6, 24
                !byte   6, 29
                !byte   7, 24
                !byte   7, 29
                !byte   8, 24
                !byte   8, 29
                !byte   9, 24
                !byte   9, 29
                !byte  10, 24
                !byte  10, 29
                !byte  11, 24
                !byte  11, 29
                !byte  11, 30
                !byte  12, 24
                !byte  12, 29
                !byte  12, 30
                !byte  13, 24
                !byte  13, 24
                !byte  13, 28
                !byte  13, 28
                !byte  13, 29
                !byte  13, 29
                !byte  13, 30
                !byte  13, 30
                !byte  14, 24
                !byte  14, 30
                !byte  14, 30
                !byte  14, 29
                !byte  14, 29
                !byte  13, 24
                !byte  13, 28
                !byte  12, 24
                !byte  12, 24
                !byte  11, 30
                !byte  11, 29
                !byte  11, 28
                !byte  11, 24
                !byte  10, 30
                !byte  10, 29
                !byte  10, 24
                !byte   9, 30
                !byte   9, 28
                !byte   8, 30
                !byte   8, 28
                !byte   7, 30
                !byte   7, 28
                !byte   6, 30
                !byte   6, 28
                !byte   5, 30
                !byte   5, 28
                !byte   4, 30
                !byte   4, 28
                !byte   3, 30
                !byte   3, 28
                !byte   3, 24
                !byte   2, 29
                !byte   2, 28
                !byte   2, 24
                !byte   1, 30
                !byte   1, 30
                !byte   1, 29
                !byte   1, 29
                !byte   1, 28
                !byte   1, 28
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   2, 28
                !byte   2, 28
                !byte   2, 29
                !byte   2, 29
                !byte   2, 30
                !byte   2, 30
                !byte   3, 24
                !byte   3, 28
                !byte   3, 29
                !byte   3, 30
                !byte   4, 24
                !byte   4, 28
                !byte   4, 30
                !byte   5, 24
                !byte   5, 29
                !byte   6, 24
                !byte   6, 29
                !byte   7, 24
                !byte   7, 29
                !byte   8, 24
                !byte   8, 29
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 23
                !byte   8, 23
                !byte   8, 22
                !byte   8, 21
                !byte   8, 21
                !byte   8, 22
                !byte   8, 23
                !byte   8, 23
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 29
                !byte   9, 24
                !byte   9, 29
                !byte  10, 24
                !byte  10, 29
                !byte  10, 30
                !byte  11, 28
                !byte  11, 29
                !byte  11, 30
                !byte  12, 24
                !byte  12, 24
                !byte  12, 28
                !byte  12, 28
                !byte  12, 29
                !byte  12, 29
                !byte  12, 30
                !byte  12, 30
                !byte  13, 24
                !byte  13, 30
                !byte  13, 30
                !byte  13, 29
                !byte  13, 29
                !byte  13, 28
                !byte  13, 28
                !byte  13, 24
                !byte  13, 24
                !byte  12, 30
                !byte  12, 29
                !byte  12, 28
                !byte  12, 24
                !byte  11, 30
                !byte  11, 29
                !byte  11, 24
                !byte  10, 30
                !byte  10, 28
                !byte   9, 30
                !byte   9, 28
                !byte   8, 30
                !byte   8, 28
                !byte   7, 30
                !byte   7, 28
                !byte   7, 24
                !byte   7, 28
                !byte   7, 30
                !byte   8, 24
                !byte   8, 29
                !byte   9, 24
                !byte   9, 29
                !byte  10, 24
                !byte  10, 29
                !byte  11, 24
                !byte  11, 29
                !byte  12, 24
                !byte  12, 29
                !byte  13, 24
                !byte  13, 29
                !byte  14, 24
                !byte  14, 29
                !byte  15, 24
                !byte  15, 29
                !byte  15, 30
                !byte  16, 28
                !byte  16, 29
                !byte  16, 30
                !byte  17, 24
                !byte  17, 24
                !byte  17, 24
                !byte  17, 24
                !byte  17, 24
                !byte  17, 23
                !byte  17, 23
                !byte  17, 22
                !byte  17, 21
                !byte  17, 21
                !byte  17, 22
                !byte  17, 23
                !byte  17, 23
                !byte  17, 24
                !byte  17, 24
                !byte  17, 24
                !byte  17, 24
                !byte  17, 24
                !byte  17, 28
                !byte  17, 28
                !byte  17, 29
                !byte  17, 29
                !byte  17, 30
                !byte  17, 30
                !byte  18, 24
                !byte  17, 30
                !byte  17, 30
                !byte  17, 29
                !byte  17, 29
                !byte  17, 28
                !byte  17, 28
                !byte  17, 24
                !byte  17, 24
                !byte  16, 30
                !byte  16, 29
                !byte  16, 28
                !byte  16, 24
                !byte  15, 28
                !byte  15, 24
                !byte  14, 30
                !byte  14, 29
                !byte  14, 24
                !byte  14, 24
                !byte  14, 24
                !byte  14, 24
                !byte  14, 24
                !byte  14, 24
                !byte  14, 23
                !byte  14, 23
                !byte  14, 22
                !byte  14, 21
                !byte  14, 21
                !byte  14, 22
                !byte  14, 23
                !byte  14, 23
                !byte  14, 24
                !byte  14, 24
                !byte  14, 24
                !byte  14, 29
                !byte  13, 30
                !byte  13, 28
                !byte  12, 30
                !byte  12, 28
                !byte  11, 30
                !byte  11, 28
                !byte  10, 30
                !byte  10, 29
                !byte  10, 28
                !byte  10, 24
                !byte  10, 23
                !byte  10, 23
                !byte  10, 23
                !byte  10, 23
                !byte  10, 23
                !byte  10, 23
                !byte  10, 22
                !byte  10, 22
                !byte  10, 22
                !byte  10, 22
                !byte  10, 21
                !byte  10, 21
                !byte  10, 21
                !byte  10, 21
                !byte  10, 21
                !byte EO_BIRDYANIMATIONTABLE    ;loop end

;from Bird #8
;y-position, shape#
bird8YAnimationTable
bird8Y0
                !byte   0,  3
                !byte   0,  6
                !byte   1,  3
                !byte   1,  6
bird8Y2
                !byte   2,  3
                !byte   2,  5
                !byte   3,  3
                !byte   3,  4
bird8Y4
                !byte   4,  3
                !byte   4,  6
                !byte   5,  3
                !byte   5,  6
bird8Y6
                !byte   6,  3
                !byte   6,  6
                !byte   7,  3
                !byte   7,  3
bird8Y8
                !byte   8,  4
                !byte   8,  6
                !byte   9,  4
                !byte   9,  6
bird8Y10
                !byte  10,  3
                !byte  10,  6
                !byte  11,  3
                !byte  11,  4
                !byte  11,  6
bird8Y12
                !byte  12,  3
                !byte  12,  3
                !byte  12,  4
                !byte  12,  5
                !byte  12,  6
                !byte  12,  6
                !byte  13,  3
                !byte  13,  4
                !byte  13,  5
                !byte  13,  6
bird8Y14
                !byte  14,  3
                !byte  14,  4
                !byte  14,  6
                !byte  15,  3
                !byte  15,  4
                !byte  15,  5
                !byte  15,  6
bird8Y16
                !byte  16,  3
                !byte  16,  4
                !byte  16,  4
                !byte  16,  5
                !byte  16,  6
                !byte  16,  6
bird8Y17
                !byte  17,  3
                !byte  16,  6
                !byte  16,  6
                !byte  16,  5
                !byte  16,  8
                !byte  16,  8
                !byte  16,  7
                !byte  16,  7
                !byte  16,  7
                !byte  15, 10
                !byte  15,  9
                !byte  15,  8
                !byte  15,  7
                !byte  15,  7
                !byte  14, 10
                !byte  14,  9
                !byte  14,  7
                !byte  14,  7
                !byte  13, 10
                !byte  13,  8
                !byte  12, 10
                !byte  12, 10
                !byte  12,  8
                !byte  11, 10
                !byte  11,  8
                !byte  10, 10
                !byte  10,  8
                !byte  10,  8
                !byte   9, 10
                !byte   9,  8
                !byte   8, 10
                !byte   8,  8
                !byte   7, 10
                !byte   7,  8
                !byte   6, 10
                !byte   6,  8
                !byte   5, 10
                !byte   5,  8
                !byte   4, 10
                !byte   4,  8
                !byte   3, 10
                !byte   3, 12
                !byte   2, 14
                !byte   2, 12
                !byte   2, 11
                !byte   1, 14
                !byte   1, 12
                !byte   0, 14
                !byte   0, 12
                !byte  -1, 14
                !byte  -1, 12
                !byte  -2, 14
                !byte  -2, 14
                !byte  -3, 14
                !byte  -3, 14
                !byte  -3, 12
                !byte  -3, 12
                !byte  -3, 11
                !byte  -4, 14
                !byte  -4, 14
                !byte  -4, 13
                !byte  -4, 13
                !byte  -4, 12
                !byte  -4, 12
                !byte  -4, 12
                !byte  -4, 11
                !byte  -4, 11
                !byte  -4, 11
                !byte  -4, 11
                !byte  -4, 11
                !byte  -4, 11
                !byte  -3, 12
                !byte  -3, 12
                !byte  -3, 13
                !byte  -3, 13
                !byte  -3, 13
                !byte  -3, 14
                !byte  -3, 14
                !byte  -3, 14
                !byte  -2, 11
                !byte  -2, 12
                !byte  -2, 13
                !byte  -2, 14
                !byte  -2, 14
                !byte  -1, 11
                !byte  -1, 11
                !byte  -1, 11
                !byte  -1, 14
                !byte  -1, 14
                !byte   0, 11
                !byte   0, 13
                !byte   1, 11
                !byte   1, 11
                !byte   1, 14
                !byte   2, 11
                !byte   2, 11
                !byte   2, 13
                !byte   3, 11
                !byte   3, 14
                !byte   4, 11
                !byte   4, 11
                !byte   4, 13
                !byte   5, 11
                !byte   5, 14
                !byte   5, 14
                !byte   6, 11
                !byte   6, 11
                !byte   6, 13
                !byte   7, 11
                !byte   7, 14
                !byte   7, 14
                !byte   8, 11
                !byte   8, 13
                !byte   9, 11
                !byte   9, 14
                !byte   9, 14
                !byte  10, 11
                !byte  10, 11
                !byte  10, 13
                !byte  11, 11
                !byte  11, 12
                !byte  11, 12
                !byte  11, 14
                !byte  11, 14
                !byte  12, 11
                !byte  12, 13
                !byte  12, 14
                !byte  13, 11
                !byte  13, 12
                !byte  13, 14
                !byte  14, 12
                !byte  14, 13
                !byte  14, 14
                !byte  15, 11
                !byte  15, 13
                !byte  15, 14
                !byte  16, 11
                !byte  16, 16
                !byte  16, 16
                !byte  16, 17
                !byte  16, 17
                !byte  16, 18
                !byte  16, 19
                !byte  16, 19
                !byte  16, 20
                !byte  16, 21
                !byte  16, 21
                !byte  15, 27
                !byte  15, 26
                !byte  15, 25
                !byte  15, 21
                !byte  14, 27
                !byte  14, 26
                !byte  14, 21
                !byte  13, 27
                !byte  13, 25
                !byte  12, 27
                !byte  12, 25
                !byte  11, 27
                !byte  11, 25
                !byte  10, 27
                !byte  10, 25
bird8YAnimationLoopStart
                !byte   9, 27       ;loop start
                !byte   9, 25
                !byte   8, 27
                !byte   8, 25
                !byte   8, 21
                !byte   7, 26
                !byte   7, 25
                !byte   7, 21
                !byte   6, 27
                !byte   6, 26
                !byte   6, 25
                !byte   6, 21
                !byte   6, 25
                !byte   6, 26
                !byte   6, 27
                !byte   7, 21
                !byte   7, 25
                !byte   7, 26
                !byte   7, 27
                !byte   7, 27
                !byte   7, 27
                !byte   7, 27
                !byte   7, 26
                !byte   7, 26
                !byte   7, 26
                !byte   7, 25
                !byte   7, 25
                !byte   7, 21
                !byte   7, 25
                !byte   7, 26
                !byte   7, 27
                !byte   8, 21
                !byte   8, 25
                !byte   8, 27
                !byte   9, 21
                !byte   9, 26
                !byte  10, 21
                !byte  10, 26
                !byte  11, 21
                !byte  11, 26
                !byte  12, 21
                !byte  12, 26
                !byte  13, 21
                !byte  13, 26
                !byte  14, 21
                !byte  14, 26
                !byte  14, 27
                !byte  15, 25
                !byte  15, 26
                !byte  15, 27
                !byte  16, 21
                !byte  16, 25
                !byte  16, 26
                !byte  16, 27
                !byte  17, 21
                !byte  17, 25
                !byte  17, 26
                !byte  17, 27
                !byte  18, 21
                !byte  18, 25
                !byte  18, 26
                !byte  18, 27
                !byte  18, 27
                !byte  18, 26
                !byte  18, 25
                !byte  18, 21
                !byte  17, 27
                !byte  17, 26
                !byte  17, 25
                !byte  17, 21
                !byte  16, 27
                !byte  16, 26
                !byte  16, 25
                !byte  16, 21
                !byte  15, 27
                !byte  15, 26
                !byte  15, 25
                !byte  15, 21
                !byte  14, 27
                !byte  14, 26
                !byte  14, 21
                !byte  13, 27
                !byte  13, 25
                !byte  12, 27
                !byte  12, 25
                !byte  11, 27
                !byte  11, 25
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 27
                !byte  10, 25
                !byte   9, 27
                !byte   9, 25
                !byte   8, 27
                !byte   8, 25
                !byte   7, 27
                !byte   7, 25
                !byte   6, 27
                !byte   6, 25
                !byte   5, 27
                !byte   5, 25
                !byte   4, 21
                !byte   4, 21
                !byte   4, 21
                !byte   4, 21
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 26
                !byte   4, 25
                !byte   4, 25
                !byte   4, 25
                !byte   4, 25
                !byte   4, 25
                !byte   3, 21
                !byte   2, 27
                !byte   2, 27
                !byte   2, 26
                !byte   2, 26
                !byte   2, 25
                !byte   2, 25
                !byte   1, 21
                !byte   1, 21
                !byte   1, 21
                !byte   1, 21
                !byte   1, 21
                !byte   1, 22
                !byte   1, 22
                !byte   1, 22
                !byte   1, 22
                !byte   1, 23
                !byte   1, 23
                !byte   1, 23
                !byte   1, 23
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 28
                !byte   1, 28
                !byte   1, 29
                !byte   1, 29
                !byte   1, 30
                !byte   1, 30
                !byte   2, 24
                !byte   2, 28
                !byte   2, 29
                !byte   2, 30
                !byte   3, 24
                !byte   3, 28
                !byte   3, 30
                !byte   4, 24
                !byte   4, 29
                !byte   5, 24
                !byte   5, 29
                !byte   6, 24
                !byte   6, 29
                !byte   7, 24
                !byte   7, 29
                !byte   8, 24
                !byte   8, 29
                !byte   9, 24
                !byte   9, 29
                !byte  10, 24
                !byte  10, 29
                !byte  11, 24
                !byte  11, 29
                !byte  11, 30
                !byte  12, 24
                !byte  12, 29
                !byte  12, 30
                !byte  12, 24
                !byte  12, 24
                !byte  11, 30
                !byte  11, 29
                !byte  11, 28
                !byte  11, 24
                !byte  10, 30
                !byte  10, 29
                !byte  10, 24
                !byte   9, 30
                !byte   9, 28
                !byte   8, 30
                !byte   8, 28
                !byte   7, 30
                !byte   7, 28
                !byte   6, 30
                !byte   6, 28
                !byte   5, 30
                !byte   5, 28
                !byte   4, 30
                !byte   4, 28
                !byte   3, 30
                !byte   3, 28
                !byte   3, 24
                !byte   2, 29
                !byte   2, 28
                !byte   2, 24
                !byte   1, 30
                !byte   1, 30
                !byte   1, 29
                !byte   1, 29
                !byte   1, 28
                !byte   1, 28
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   1, 24
                !byte   2, 28
                !byte   2, 28
                !byte   2, 29
                !byte   2, 29
                !byte   2, 30
                !byte   2, 30
                !byte   3, 24
                !byte   3, 28
                !byte   3, 29
                !byte   3, 30
                !byte   4, 24
                !byte   4, 28
                !byte   4, 30
                !byte   5, 24
                !byte   5, 29
                !byte   6, 24
                !byte   6, 29
                !byte   7, 24
                !byte   7, 29
                !byte   8, 24
                !byte   8, 29
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 23
                !byte   8, 23
                !byte   8, 22
                !byte   8, 21
                !byte   8, 21
                !byte   8, 22
                !byte   8, 23
                !byte   8, 23
                !byte   8, 24
                !byte   8, 24
                !byte   8, 24
                !byte   8, 29
                !byte   9, 24
                !byte   9, 29
                !byte  10, 24
                !byte  10, 29
                !byte  10, 30
                !byte  11, 28
                !byte  11, 29
                !byte  11, 30
                !byte  12, 24
                !byte  12, 24
                !byte  12, 28
                !byte  12, 28
                !byte  12, 29
                !byte  12, 29
                !byte  12, 30
                !byte  12, 30
                !byte  13, 24
                !byte  13, 30
                !byte  13, 30
                !byte  13, 29
                !byte  13, 29
                !byte  13, 28
                !byte  13, 28
                !byte  13, 24
                !byte  13, 24
                !byte  12, 30
                !byte  12, 29
                !byte  12, 28
                !byte  12, 24
                !byte  11, 30
                !byte  11, 29
                !byte  11, 24
                !byte  10, 30
                !byte  10, 28
                !byte   9, 30
                !byte   9, 28
                !byte   8, 30
                !byte   8, 28
                !byte   7, 30
                !byte   7, 28
                !byte   6, 30
                !byte   6, 28
                !byte   6, 24
                !byte   5, 29
                !byte   5, 28
                !byte   5, 24
                !byte   4, 30
                !byte   4, 30
                !byte   4, 29
                !byte   4, 29
                !byte   4, 28
                !byte   4, 28
                !byte   4, 24
                !byte   4, 24
                !byte   4, 24
                !byte   4, 24
                !byte   5, 28
                !byte   5, 28
                !byte   5, 29
                !byte   5, 29
                !byte   5, 29
                !byte   5, 30
                !byte   5, 30
                !byte   6, 24
                !byte   6, 28
                !byte   6, 29
                !byte   6, 30
                !byte   7, 24
                !byte   7, 28
                !byte   7, 30
                !byte   8, 24
                !byte   8, 29
                !byte   9, 24
                !byte   9, 29
                !byte  10, 24
                !byte  10, 29
                !byte  11, 24
                !byte  11, 29
                !byte  12, 24
                !byte  12, 29
                !byte  13, 24
                !byte  13, 29
                !byte  14, 24
                !byte  14, 29
                !byte  14, 30
                !byte  14, 29
                !byte  14, 24
                !byte  14, 24
                !byte  14, 24
                !byte  14, 24
                !byte  14, 24
                !byte  14, 24
                !byte  14, 23
                !byte  14, 23
                !byte  14, 22
                !byte  14, 21
                !byte  14, 21
                !byte  14, 22
                !byte  14, 23
                !byte  14, 23
                !byte  14, 24
                !byte  14, 24
                !byte  14, 24
                !byte  14, 29
                !byte  13, 30
                !byte  13, 28
                !byte  12, 30
                !byte  12, 28
                !byte  11, 30
                !byte  11, 28
                !byte  10, 30
                !byte  10, 29
                !byte  10, 28
                !byte  10, 24
                !byte  10, 23
                !byte  10, 23
                !byte  10, 23
                !byte  10, 23
                !byte  10, 23
                !byte  10, 23
                !byte  10, 22
                !byte  10, 22
                !byte  10, 22
                !byte  10, 22
                !byte  10, 21
                !byte  10, 21
                !byte  10, 21
                !byte  10, 21
                !byte  10, 21
                !byte  10, 20
                !byte  10, 20
                !byte  10, 19
                !byte  10, 19
                !byte  10, 18
                !byte  10, 18
                !byte  10, 17
                !byte  10, 17
                !byte  10, 16
                !byte  10, 16
                !byte  10, 15
                !byte  10, 15
                !byte  10, 14
                !byte  10, 14
                !byte  10, 13
                !byte  10, 13
                !byte  10, 12
                !byte  10, 12
                !byte  10, 11
                !byte  10, 11
                !byte  10, 10
                !byte  10, 10
                !byte  10, 09
                !byte  10, 08
                !byte  10, 07
                !byte  10, 08
                !byte  10, 09
                !byte  10, 10
                !byte  10, 10
                !byte  10, 11
                !byte  10, 11
                !byte  10, 12
                !byte  10, 12
                !byte  10, 13
                !byte  10, 13
                !byte  10, 14
                !byte  10, 14
                !byte  10, 15
                !byte  10, 15
                !byte  10, 16
                !byte  10, 16
                !byte  10, 17
                !byte  10, 17
                !byte  10, 18
                !byte  10, 18
                !byte  10, 19
                !byte  10, 19
                !byte  10, 20
                !byte  10, 20
                !byte  10, 21
                !byte EO_BIRDYANIMATIONTABLE    ;loop end

birdYAnimationLoopStartTableLow
                !byte <bird1YAnimationLoopStart
                !byte <bird2YAnimationLoopStart
                !byte <bird3YAnimationLoopStart
                !byte <bird4YAnimationLoopStart
                !byte <bird5YAnimationLoopStart
                !byte <bird6YAnimationLoopStart
                !byte <bird7YAnimationLoopStart
                !byte <bird8YAnimationLoopStart

birdYAnimationLoopStartTableHigh
                !byte >bird1YAnimationLoopStart
                !byte >bird2YAnimationLoopStart
                !byte >bird3YAnimationLoopStart
                !byte >bird4YAnimationLoopStart
                !byte >bird5YAnimationLoopStart
                !byte >bird6YAnimationLoopStart
                !byte >bird7YAnimationLoopStart
                !byte >bird8YAnimationLoopStart


;bird Y movement data ***********************************************
birdYMoveOffsetTableLow
                !fill BIRDS_MAX,0

birdYMoveOffsetTableHigh
                !fill BIRDS_MAX,0

birdFleetInitialArray
                !fill BIRDS_MAX, PRESENT    ;bird #1,#2,#3,...

birdInitialXArray
                !fill BIRDS_MAX,0           ;0-39

birdInitialYLowArray
                !fill BIRDS_MAX,0           ;start of birdYAnimationTable - end of birdYAnimationTable

birdInitialYHighArray
                !fill BIRDS_MAX,0

;bird formation A
birdFormAArray
                !byte  35,  33,  31,  29,  27,  25,  23,  21    ;x positions
;birdYAnimationTable offsets for y positions
                !byte   <bird1Y2                    ;y=2
                !byte   <bird2Y4                    ;y=4
                !byte   <bird3Y6                    ;y=6
                !byte   <bird4Y8                    ;y=8
                !byte   <bird5Y10                   ;y=10
                !byte   <bird6Y12                   ;y=12
                !byte   <bird7Y14                   ;y=14
                !byte   <bird8Y16                   ;y=16
                !byte   >bird1Y2                    ;y=2
                !byte   >bird2Y4                    ;y=4
                !byte   >bird3Y6                    ;y=6
                !byte   >bird4Y8                    ;y=8
                !byte   >bird5Y10                   ;y=10
                !byte   >bird6Y12                   ;y=12
                !byte   >bird7Y14                   ;y=14
                !byte   >bird8Y16                   ;y=16
;bird formation B
birdFormBArray
                !byte  35,  32,  29,  26,  23,  20,  17,  14    ;x positions
;birdYAnimationTable offsets for y positions
                !byte   <bird1Y17                   ;y=17
                !byte   <bird2Y0                    ;y=0
                !byte   <bird3Y17+002               ;y=17+
                !byte   <bird4Y0+002                ;y=0+
                !byte   <bird5Y17+004               ;y=17++
                !byte   <bird6Y0+004                ;y=0++
                !byte   <bird7Y17+006               ;y=17+++
                !byte   <bird8Y0+006                ;y=0+++
                !byte   >bird1Y17                   ;y=17
                !byte   >bird2Y0                    ;y=0
                !byte   >bird3Y17+002               ;y=17+
                !byte   >bird4Y0+002                ;y=0+
                !byte   >bird5Y17+004               ;y=17++
                !byte   >bird6Y0+004                ;y=0++
                !byte   >bird7Y17+006               ;y=17+++
                !byte   >bird8Y0+006                ;y=0+++

;bird formation address table
birdFormationTableLow
                !byte <birdFormAArray
                !byte <birdFormBArray

birdFormationTableHigh
                !byte >birdFormAArray
                !byte >birdFormBArray

birdFleetArray
                !fill BIRDS_MAX,0

birdFleetXposArray
                !fill BIRDS_MAX,0

birdFleetYposArray
                !fill BIRDS_MAX,0

birdFleetOldXposArray
                !fill BIRDS_MAX,0

birdFleetOldYposArray
                !fill BIRDS_MAX,0

birdShapeTypeArray
                !fill BIRDS_MAX, 0

;fade in bird frame table
fadeinBirdFrameLow
                !byte <bird01Shape
                !byte <bird02Shape
                !byte <bird03Shape

fadeinBirdFrameHigh
                !byte >bird01Shape
                !byte >bird02Shape
                !byte >bird03Shape

;fade in bird color table
fadeinBirdColorFrameLow
                !byte <bird01Color
                !byte <bird02Color
                !byte <bird03Color

fadeinBirdColorFrameHigh
                !byte >bird01Color
                !byte >bird02Color
                !byte >bird03Color

birdShapeTable
bird00Shape
                !byte CHR_SPACE,CHR_SPACE
                !byte CHR_SPACE,CHR_SPACE
                !byte CHR_SPACE,CHR_SPACE
                !byte CHR_SPACE,CHR_SPACE
                !byte CHR_SPACE,CHR_SPACE
                !byte CHR_SPACE,CHR_SPACE
                !byte CHR_SPACE,CHR_SPACE

bird01Shape
                !byte 000,000
                !byte 000,042
                !byte 000,254
                !byte 000,042
                !byte 000,000
                !byte 000,000
                !byte 000,000

bird02Shape
                !byte 000,000
                !byte 000,042
                !byte 000,255
                !byte 000,042
                !byte 000,000
                !byte 000,000
                !byte 000,000

bird03Shape
                !byte 000,000
                !byte 000,042
                !byte 000,144
                !byte 000,042
                !byte 000,000
                !byte 000,000
                !byte 000,000

bird04Shape
                !byte 000,000
                !byte 000,042
                !byte 000,145
                !byte 000,042
                !byte 000,000
                !byte 000,000
                !byte 000,000

bird05Shape
                !byte 000,000
                !byte 000,042
                !byte 000,146
                !byte 000,147
                !byte 000,042
                !byte 000,000
                !byte 000,000

bird06Shape
                !byte 000,000
                !byte 000,042
                !byte 000,148
                !byte 000,149
                !byte 000,042
                !byte 000,000
                !byte 000,000

bird07Shape
                !byte 000,000
                !byte 000,042
                !byte 000,150
                !byte 000,042
                !byte 000,000
                !byte 000,000
                !byte 000,000

bird08Shape
                !byte 000,000
                !byte 000,042
                !byte 000,151
                !byte 000,147
                !byte 000,042
                !byte 000,000
                !byte 000,000

bird09Shape
                !byte 000,000
                !byte 000,042
                !byte 000,152
                !byte 000,153
                !byte 000,042
                !byte 000,000
                !byte 000,000

bird10Shape
                !byte 000,000
                !byte 000,042
                !byte 000,154
                !byte 000,155
                !byte 000,042
                !byte 000,000
                !byte 000,000

bird11Shape
                !byte 000,000
                !byte 000,042
                !byte 000,156
                !byte 000,042
                !byte 000,000
                !byte 000,000
                !byte 000,000

bird12Shape
                !byte 000,000
                !byte 000,042
                !byte 000,157
                !byte 000,158
                !byte 000,042
                !byte 000,000
                !byte 000,000

bird13Shape
                !byte 000,000
                !byte 000,042
                !byte 000,159
                !byte 000,160
                !byte 000,042
                !byte 000,000
                !byte 000,000

bird14Shape
                !byte 000,000
                !byte 000,042
                !byte 000,161
                !byte 000,162
                !byte 000,042
                !byte 000,000
                !byte 000,000

bird15Shape
                !byte 000,000
                !byte 000,000
                !byte 042,042
                !byte 042,156
                !byte 042,042
                !byte 000,000
                !byte 000,000

bird16Shape
                !byte 000,000
                !byte 042,042
                !byte 165,163
                !byte 166,164
                !byte 042,042
                !byte 000,000
                !byte 000,000

bird17Shape
                !byte 000,000
                !byte 042,042
                !byte 169,167
                !byte 170,168
                !byte 042,042
                !byte 000,000
                !byte 000,000

bird18Shape
                !byte 000,000
                !byte 042,042
                !byte 173,171
                !byte 174,172
                !byte 042,042
                !byte 000,000
                !byte 000,000

bird19Shape
                !byte 000,042
                !byte 042,222
                !byte 176,171
                !byte 177,172
                !byte 042,223
                !byte 000,042
                !byte 000,000

bird20Shape
                !byte 042,042
                !byte 224,222
                !byte 178,171
                !byte 179,172
                !byte 225,223
                !byte 042,042
                !byte 000,000

bird21Shape
                !byte 042,042
                !byte 226,222
                !byte 178,171
                !byte 179,172
                !byte 227,223
                !byte 042,042
                !byte 042,042

bird22Shape
                !byte 042,042
                !byte 252,250
                !byte 217,215
                !byte 218,216
                !byte 253,251
                !byte 042,042
                !byte 042,042

bird23Shape
                !byte 246,244
                !byte 042,245
                !byte 198,196
                !byte 199,197
                !byte 042,247
                !byte 249,248
                !byte 042,042

bird24Shape
                !byte 042,232
                !byte 042,233
                !byte 198,196
                !byte 199,197
                !byte 042,234
                !byte 042,235
                !byte 042,042

;for horizontal movement
bird25Shape
                !byte 042,042
                !byte 229,042
                !byte 182,180
                !byte 183,181
                !byte 230,228
                !byte 042,042
                !byte 042,042

bird26Shape
                !byte 042,042
                !byte 042,042
                !byte 187,184
                !byte 188,185
                !byte 189,186
                !byte 042,042
                !byte 042,042

bird27Shape
                !byte 042,042
                !byte 042,042
                !byte 193,190
                !byte 194,191
                !byte 195,192
                !byte 231,042
                !byte 042,042

bird28Shape
                !byte 042,236
                !byte 042,233
                !byte 202,200
                !byte 203,201
                !byte 042,234
                !byte 042,237
                !byte 042,042

bird29Shape
                !byte 042,238
                !byte 042,239
                !byte 207,204
                !byte 208,205
                !byte 209,206
                !byte 042,240
                !byte 042,241

bird30Shape
                !byte 042,242
                !byte 042,239
                !byte 042,210
                !byte 213,211
                !byte 214,212
                !byte 042,240
                !byte 042,243


;color of shapes
birdColorTable
bird00Color
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT

bird01Color
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT

bird02Color
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT

bird03Color
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,YEL6
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT

bird04Color
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,YEL6
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT

bird05Color
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,YEL6
                !byte WHT,YEL6
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT

bird06Color
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,YEL6
                !byte WHT,YEL6
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT

bird07Color
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,YEL6
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT

bird08Color
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,YEL6
                !byte WHT,YEL6
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT

bird09Color
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,YEL6
                !byte WHT,YEL6
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT

bird10Color
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,YEL6
                !byte WHT,YEL6
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT

bird11Color
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,YEL6
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT

bird12Color
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,YEL6
                !byte WHT,YEL6
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT

bird13Color
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0

bird14Color
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0

bird15Color
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0

bird16Color
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0

bird17Color
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0

bird18Color
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0

bird19Color
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0

bird20Color
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0

bird21Color
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0

bird22Color
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0

bird23Color
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0

bird24Color
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0

;for horizontal movement
bird25Color
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0

bird26Color
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0

bird27Color
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0

bird28Color
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0

bird29Color
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0

bird30Color
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0
                !byte 0,0

;color set 1
birdColorSet1
;bird13Color
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,YEL6
                !byte WHT,CYN6
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT

;bird14Color
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,CYN6
                !byte WHT,CYN6
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT

;bird15Color
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,YEL6
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT

;bird16Color
                !byte WHT,WHT
                !byte WHT,WHT
                !byte CYN6,CYN6
                !byte CYN6,CYN6
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT

;bird17Color
                !byte WHT,WHT
                !byte WHT,WHT
                !byte CYN6,CYN6
                !byte CYN6,CYN6
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT

;bird18Color
                !byte WHT,WHT
                !byte WHT,WHT
                !byte YEL6,CYN6
                !byte YEL6,CYN6
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT

;bird19Color
                !byte WHT,WHT
                !byte WHT,CYN6
                !byte YEL6,CYN6
                !byte YEL6,CYN6
                !byte WHT,CYN6
                !byte WHT,WHT
                !byte WHT,WHT

;bird20Color
                !byte WHT,WHT
                !byte CYN6,CYN6
                !byte YEL6,CYN6
                !byte YEL6,CYN6
                !byte CYN6,CYN6
                !byte WHT,WHT
                !byte WHT,WHT

;bird21Color
                !byte WHT,WHT
                !byte CYN6,CYN6
                !byte YEL6,CYN6
                !byte YEL6,CYN6
                !byte CYN6,CYN6
                !byte WHT,WHT
                !byte WHT,WHT

;bird22Color
                !byte WHT,WHT
                !byte CYN6,CYN6
                !byte YEL6,CYN6
                !byte YEL6,CYN6
                !byte CYN6,CYN6
                !byte WHT,WHT
                !byte WHT,WHT

;bird23Color
                !byte CYN6,CYN6
                !byte WHT,CYN6
                !byte YEL6,CYN6
                !byte YEL6,CYN6
                !byte WHT,CYN6
                !byte CYN6,CYN6
                !byte WHT,WHT

;bird24Color
                !byte WHT,CYN6
                !byte WHT,CYN6
                !byte YEL6,CYN6
                !byte YEL6,CYN6
                !byte WHT,CYN6
                !byte WHT,CYN6
                !byte WHT,WHT
;for horizontal movement
;bird25Color
                !byte WHT,WHT
                !byte CYN6,WHT
                !byte CYN6,CYN6
                !byte YEL6,CYN6
                !byte CYN6,CYN6
                !byte WHT,WHT
                !byte WHT,WHT

;bird26Color
                !byte WHT,WHT
                !byte WHT,WHT
                !byte CYN6,CYN6
                !byte YEL6,CYN6
                !byte CYN6,CYN6
                !byte WHT,WHT
                !byte WHT,WHT

;bird27Color
                !byte WHT,WHT
                !byte WHT,WHT
                !byte CYN6,CYN6
                !byte YEL6,CYN6
                !byte CYN6,CYN6
                !byte CYN6,WHT
                !byte WHT,WHT

;bird28Color
                !byte WHT,CYN6
                !byte WHT,CYN6
                !byte YEL6,CYN6
                !byte YEL6,CYN6
                !byte WHT,CYN6
                !byte WHT,CYN6
                !byte WHT,WHT

;bird29Color
                !byte WHT,CYN6
                !byte WHT,CYN6
                !byte YEL6,CYN6
                !byte YEL6,CYN6
                !byte YEL6,CYN6
                !byte WHT,CYN6
                !byte WHT,CYN6

;bird30Color
                !byte WHT,CYN6
                !byte WHT,CYN6
                !byte WHT,CYN6
                !byte YEL6,CYN6
                !byte YEL6,CYN6
                !byte WHT,CYN6
                !byte WHT,CYN6

;color set 2
birdColorSet2
;bird13Color
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,YEL6
                !byte WHT,PUR
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT

;bird14Color
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,PUR
                !byte WHT,PUR
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT

;bird15Color
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,YEL6
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT

;bird16Color
                !byte WHT,WHT
                !byte WHT,WHT
                !byte PUR,PUR
                !byte PUR,PUR
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT

;bird17Color
                !byte WHT,WHT
                !byte WHT,WHT
                !byte PUR,PUR
                !byte PUR,PUR
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT

;bird18Color
                !byte WHT,WHT
                !byte WHT,WHT
                !byte YEL6,PUR
                !byte YEL6,PUR
                !byte WHT,WHT
                !byte WHT,WHT
                !byte WHT,WHT

;bird19Color
                !byte WHT,WHT
                !byte WHT,PUR
                !byte YEL6,PUR
                !byte YEL6,PUR
                !byte WHT,PUR
                !byte WHT,WHT
                !byte WHT,WHT

;bird20Color
                !byte WHT,WHT
                !byte PUR,PUR
                !byte YEL6,PUR
                !byte YEL6,PUR
                !byte PUR,PUR
                !byte WHT,WHT
                !byte WHT,WHT

;bird21Color
                !byte WHT,WHT
                !byte PUR,PUR
                !byte YEL6,PUR
                !byte YEL6,PUR
                !byte PUR,PUR
                !byte WHT,WHT
                !byte WHT,WHT

;bird22Color
                !byte WHT,WHT
                !byte PUR,PUR
                !byte YEL6,PUR
                !byte YEL6,PUR
                !byte PUR,PUR
                !byte WHT,WHT
                !byte WHT,WHT

;bird23Color
                !byte PUR,PUR
                !byte WHT,PUR
                !byte YEL6,PUR
                !byte YEL6,PUR
                !byte WHT,PUR
                !byte PUR,PUR
                !byte WHT,WHT

;bird24Color
                !byte WHT,PUR
                !byte WHT,PUR
                !byte YEL6,PUR
                !byte YEL6,PUR
                !byte WHT,PUR
                !byte WHT,PUR
                !byte WHT,WHT
;for horizontal movement
;bird25Color
                !byte WHT,WHT
                !byte PUR,WHT
                !byte PUR,PUR
                !byte YEL6,PUR
                !byte PUR,PUR
                !byte WHT,WHT
                !byte WHT,WHT

;bird26Color
                !byte WHT,WHT
                !byte WHT,WHT
                !byte PUR,PUR
                !byte YEL6,PUR
                !byte PUR,PUR
                !byte WHT,WHT
                !byte WHT,WHT

;bird27Color
                !byte WHT,WHT
                !byte WHT,WHT
                !byte PUR,PUR
                !byte YEL6,PUR
                !byte PUR,PUR
                !byte PUR,WHT
                !byte WHT,WHT

;bird28Color
                !byte WHT,PUR
                !byte WHT,PUR
                !byte YEL6,PUR
                !byte YEL6,PUR
                !byte WHT,PUR
                !byte WHT,PUR
                !byte WHT,WHT

;bird29Color
                !byte WHT,PUR
                !byte WHT,PUR
                !byte YEL6,PUR
                !byte YEL6,PUR
                !byte YEL6,PUR
                !byte WHT,PUR
                !byte WHT,PUR

;bird30Color
                !byte WHT,PUR
                !byte WHT,PUR
                !byte WHT,PUR
                !byte YEL6,PUR
                !byte YEL6,PUR
                !byte WHT,PUR
                !byte WHT,PUR

;bird address tables
birdShapeAddrTableLow
                !byte <bird00Shape
                !byte <bird01Shape
                !byte <bird02Shape
                !byte <bird03Shape
                !byte <bird04Shape
                !byte <bird05Shape
                !byte <bird06Shape
                !byte <bird07Shape
                !byte <bird08Shape
                !byte <bird09Shape
                !byte <bird10Shape
                !byte <bird11Shape
                !byte <bird12Shape
                !byte <bird13Shape
                !byte <bird14Shape
                !byte <bird15Shape
                !byte <bird16Shape
                !byte <bird17Shape
                !byte <bird18Shape
                !byte <bird19Shape
                !byte <bird20Shape
                !byte <bird21Shape
                !byte <bird22Shape
                !byte <bird23Shape
                !byte <bird24Shape
                !byte <bird25Shape
                !byte <bird26Shape
                !byte <bird27Shape
                !byte <bird28Shape
                !byte <bird29Shape
                !byte <bird30Shape

birdShapeAddrTableHigh
                !byte >bird00Shape
                !byte >bird01Shape
                !byte >bird02Shape
                !byte >bird03Shape
                !byte >bird04Shape
                !byte >bird05Shape
                !byte >bird06Shape
                !byte >bird07Shape
                !byte >bird08Shape
                !byte >bird09Shape
                !byte >bird10Shape
                !byte >bird11Shape
                !byte >bird12Shape
                !byte >bird13Shape
                !byte >bird14Shape
                !byte >bird15Shape
                !byte >bird16Shape
                !byte >bird17Shape
                !byte >bird18Shape
                !byte >bird19Shape
                !byte >bird20Shape
                !byte >bird21Shape
                !byte >bird22Shape
                !byte >bird23Shape
                !byte >bird24Shape
                !byte >bird25Shape
                !byte >bird26Shape
                !byte >bird27Shape
                !byte >bird28Shape
                !byte >bird29Shape
                !byte >bird30Shape

birdColorAddrTableLow
                !byte <bird00Color
                !byte <bird01Color
                !byte <bird02Color
                !byte <bird03Color
                !byte <bird04Color
                !byte <bird05Color
                !byte <bird06Color
                !byte <bird07Color
                !byte <bird08Color
                !byte <bird09Color
                !byte <bird10Color
                !byte <bird11Color
                !byte <bird12Color
                !byte <bird13Color
                !byte <bird14Color
                !byte <bird15Color
                !byte <bird16Color
                !byte <bird17Color
                !byte <bird18Color
                !byte <bird19Color
                !byte <bird20Color
                !byte <bird21Color
                !byte <bird22Color
                !byte <bird23Color
                !byte <bird24Color
                !byte <bird25Color
                !byte <bird26Color
                !byte <bird27Color
                !byte <bird28Color
                !byte <bird29Color
                !byte <bird30Color

birdColorAddrTableHigh
                !byte >bird00Color
                !byte >bird01Color
                !byte >bird02Color
                !byte >bird03Color
                !byte >bird04Color
                !byte >bird05Color
                !byte >bird06Color
                !byte >bird07Color
                !byte >bird08Color
                !byte >bird09Color
                !byte >bird10Color
                !byte >bird11Color
                !byte >bird12Color
                !byte >bird13Color
                !byte >bird14Color
                !byte >bird15Color
                !byte >bird16Color
                !byte >bird17Color
                !byte >bird18Color
                !byte >bird19Color
                !byte >bird20Color
                !byte >bird21Color
                !byte >bird22Color
                !byte >bird23Color
                !byte >bird24Color
                !byte >bird25Color
                !byte >bird26Color
                !byte >bird27Color
                !byte >bird28Color
                !byte >bird29Color
                !byte >bird30Color

;bird animation frames for intro
birdAnimationFrameTable
                !byte 01,02,03,04,05,06
                !byte 07,08,09,10
                !byte 11,12,13,14
                !byte 12,13,15
                !byte 16,17,18,19,20
                !byte 21,22,23,24,24,23,22
                !byte 21,21,22,23,24,24,23,22
                !byte 21,21,22,23,24,24,23,22
                !byte 21,21,22,23,24,24,23,22
                !byte 21,21,22,23,24,24,23,22
                !byte 21,20,19,18,17,16
                !byte 15,13,12,11,12,13
                !byte 14,07,08,09,10,03,04,05,06
                !byte 00,01,02

birdAnimationOffsetTable
                !byte 07,07,07,07,07,07
                !byte 07,07,07,07
                !byte 07,07,07,07
                !byte 07,07,07
                !byte 08,08,08,08,08
                !byte 08,08,08,08,08,08,08
                !byte 08,08,08,08,08,08,08,08
                !byte 08,08,08,08,08,08,08,08
                !byte 08,08,08,08,08,08,08,08
                !byte 08,08,08,08,08,08,08,08
                !byte 08,08,08,08,08,08
                !byte 07,07,07,07,07,07
                !byte 07,07,07,07,07,07,07,07,07
                !byte 07,07,07

;********************************************************************
; BIRD MODULE END                                                   *
;********************************************************************